var curUserId = '';
var dontTouchPiece = '';
var curOrientation = '';
var highlightLastMove = 'highlightLastMove';
var lastMoveDetail = [];
var lastMoved = '';

var boardDetails = {
    boardId: '123456789',
    whiteId: '1234',
    blackId: '5678',
    player1Name: 'WhitePlayer',
    player2Name: 'BlackPlayer',
    moveDetail: 'rnbqkbn1/p3p1pr/1ppP4/5p2/7r/2PP1P2/PP2N1PP/RNBQKB1R w KQq - 1 7',
    result: '*',
    message: '',
    lastMove: 'g2-g4',
    isWhiteOnline: true,
    isBlackOnline: true,
    lastMovedBy: '5678',
    lastMovedDate: '01-01-2017',
    isDaysExceeded: false,
    timeLimit: '',
    whiteRemovedPieces: '',
    blackRemovedPieces: '',
    drawRequestedBy: '',
    drawApprovedBy: ''
};

//rnbqkbn1/p3p1pr/1ppP4/5p2/7r/2PP1P2/PP2N1PP/RNBQKB1R w KQq - 1 7 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1'
var startPostition = '';// boardDetails.notation;// "rnbqkbn1/p3p1pr/1ppP4/5p2/7r/2PP1P2/PP2N1PP/RNBQKB1R b KQq";
var startNotation = '';// boardDetails.notationDetail;// "rnbqkbn1/p3p1pr/1ppP4/5p2/7r/2PP1P2/PP2N1PP/RNBQKB1R b KQq - 1 7";

function PopulateBoardDetail(curBoardDetail, $scope) {
    // alert("boardId");
    // Populate Detail

    if (curBoardDetail == null || curBoardDetail.BoardId == null || boardDetails.moveDetail == null)
        return;

    boardDetails.boardId = curBoardDetail.BoardId;
    boardDetails.whiteId = curBoardDetail.WhiteId;
    boardDetails.blackId = curBoardDetail.BlackId;
    boardDetails.player1Name = curBoardDetail.WhiteUserName;
    boardDetails.player2Name = curBoardDetail.BlackUserName;
    boardDetails.moveDetail = curBoardDetail.MoveDetail;
    boardDetails.result = curBoardDetail.Result;
    boardDetails.message = curBoardDetail.Message;
    boardDetails.lastMove = curBoardDetail.LastMove;
    boardDetails.isWhiteOnline = curBoardDetail.IsWhiteOnline;
    boardDetails.isBlackOnline = curBoardDetail.IsBlackOnline;
    boardDetails.lastMovedDate = curBoardDetail.LastMovedDate;
    boardDetails.isDaysExceeded = curBoardDetail.IsDaysExceeded;
    boardDetails.timeLimit = curBoardDetail.TimeLimit;
    boardDetails.lastMovedBy = curBoardDetail.LastMovedBy;
    boardDetails.whiteRemovedPieces = curBoardDetail.WhiteRemovedPieces;
    boardDetails.blackRemovedPieces = curBoardDetail.BlackRemovedPieces;
    boardDetails.drawRequestedBy = curBoardDetail.DrawRequestedBy;
    boardDetails.drawApprovedBy = curBoardDetail.DrawApprovedBy;

    var notationSplit = boardDetails.moveDetail.split(/\s+/);

    startNotation = boardDetails.moveDetail;
    startPostition = notationSplit[0];

    LoadLastMoveOnBoard(boardDetails);
    LoadBoard($scope);
    LoadRemovedPiecesCount(boardDetails);
}

function LoadLastMoveOnBoard(bDetail) {
    lastMoveDetail = [];

    if (bDetail != null && bDetail.lastMove != "") {
        var cellSplit = bDetail.lastMove.split("-");
        if (cellSplit != null && cellSplit.length > 0) {
            for (var i = 0; i < cellSplit.length ; i++) {
                lastMoveDetail.push(cellSplit[i]);
            }
        }
    }
}

function PopulateBoardDetailDebug(curBoardDetail, $scope) {

    var notationSplit = boardDetails.moveDetail.split(/\s+/);

    startNotation = boardDetails.moveDetail;
    startPostition = notationSplit[0];

    LoadLastMoveOnBoard(boardDetails);
    LoadBoard($scope);
}

function LoadOuterBoard() {
    //alert("onLoad");

    dontTouchPiece = '';
    $("#btnClaimWin").css("display", "none");
    $("#btnResign").css("display", "none");

    //$("#id").css("display", "none");
    //$("#id").css("display", "block");

    if (curUserId === boardDetails.whiteId) {
        curOrientation = 'white';
        dontTouchPiece = 'b';

        if (boardDetails.isDaysExceeded && boardDetails.lastMovedBy === boardDetails.whiteId) {
            $("#btnClaimWin").css("display", "block");
        }

        HideDrawButtons();

        if (boardDetails.result == '*') {
            $("#btnResign").css("display", "block");
            ManageDrawButton();
        }

        $("#upPlayer").html(boardDetails.player2Name);
        $("#downPlayer").html(boardDetails.player1Name);

        $("#btnChat").css("display", "block");
    }
    else if (curUserId === boardDetails.blackId) {
        curOrientation = 'black';
        dontTouchPiece = 'w';

        if (boardDetails.isDaysExceeded && boardDetails.lastMovedBy === boardDetails.blackId) {
            $("#btnClaimWin").css("display", "block");
        }

        HideDrawButtons();
        if (boardDetails.result == '*') {
            $("#btnResign").css("display", "block");
            ManageDrawButton();
        }

        $("#upPlayer").html(boardDetails.player1Name);
        $("#downPlayer").html(boardDetails.player2Name);

        $("#btnChat").css("display", "block");
    }
    else {
        dontTouchPiece = 'YES';
        curOrientation = 'white';

        $("#upPlayer").html(boardDetails.player2Name);
        $("#downPlayer").html(boardDetails.player1Name);
    }

    if (boardDetails.result != "*") {
        dontTouchPiece = 'YES';
    }

    $('#divTimeLimit').html(boardDetails.timeLimit);
    $('#divProgress').html(boardDetails.message);
    $("#divLastMovedOn").html('Last Move done On <b>' + boardDetails.lastMovedDate + '<b>');


    $('#divBoard').css("display", "block");
    $('#divRemovedPieceContainer').css("display", "block");
    $('#divBottomOfBoard').css("display", "block");
}

function HideDrawButtons()
{
    $("#btnRequestDraw").css("display", "none");
    $("#btnApproveDraw").css("display", "none");
}

function ManageDrawButton() {
    if ((boardDetails.drawRequestedBy == null ||
        boardDetails.drawRequestedBy == 'undefined' || boardDetails.drawRequestedBy == "") &&
        (boardDetails.drawApprovedBy == null || boardDetails.drawApprovedBy == "")) {
        $("#btnRequestDraw").css("display", "block");
        $("#btnApproveDraw").css("display", "none");
    }
    else if (boardDetails.drawRequestedBy != null &&
        boardDetails.drawRequestedBy !== 'undefined' && boardDetails.drawRequestedBy != "" &&
        boardDetails.drawRequestedBy == curUserId) {
        $("#btnRequestDraw").css("display", "none");
        $("#btnApproveDraw").css("display", "none");
    }
    else if (boardDetails.drawRequestedBy != null && boardDetails.drawRequestedBy !== 'undefined' && boardDetails.drawRequestedBy != "" &&
        boardDetails.drawRequestedBy != curUserId && (boardDetails.drawApprovedBy == null || boardDetails.drawApprovedBy == "")) {
        $("#btnRequestDraw").css("display", "none");
        $("#btnApproveDraw").css("display", "block");
    }
    else if (boardDetails.drawApprovedBy != null &&
        boardDetails.drawApprovedBy !== 'undefined' && boardDetails.drawApprovedBy != "") {
        $("#btnRequestDraw").css("display", "none");
        $("#btnApproveDraw").css("display", "none");
    }
}

function LoadBoard($scope) {
    LoadOuterBoard();

    var canUpdate = false;

    var board,
    game = new Chess();
    statusEl = $('#status'),
    fenEl = $('#fen'),
    pgnEl = $('#pgn');

    var removeGreySquares = function () {
        $('#board .square-55d63').css('background', '');
    };

    var greySquare = function (square) {
        var squareEl = $('#board .square-' + square);
        var background = '#a9a9a9';
        if (squareEl.hasClass('black-3c85d') === true) {
            background = '#696969';
        }

        squareEl.css('background', background);
    };

    var greyedSquareOut = function (square) {
        var squareEl = $('#board .square-' + square);
        var background = '#a9a9a9';
        if (squareEl.hasClass('black-3c85d') === true) {
            background = '#696969';
        }

        squareEl.css('background', background);
    };

    var onDragStart = function (source, piece) {
        if (game.game_over() === true || dontTouchPiece === 'YES' ||
         (game.turn() === 'w' && piece.search(/^b/) !== -1) ||
         (game.turn() === 'b' && piece.search(/^w/) !== -1) ||
         piece.indexOf(dontTouchPiece) === 0) {
            return false;
        }
    };

    var onLastMoveRemoveHighlight = function () {
        if (lastMoveDetail != null && lastMoveDetail.length > 0) {
            for (var i = 0; i < lastMoveDetail.length; i++) {
                $('.square-' + lastMoveDetail[i]).removeClass(highlightLastMove);
            }
        }

        lastMoveDetail = [];
    }

    var onLastMoveAddHighlight = function () {
        if (lastMoveDetail != null && lastMoveDetail.length > 0) {
            for (var i = 0; i < lastMoveDetail.length; i++) {
                $('.square-' + lastMoveDetail[i]).addClass(highlightLastMove);
            }
        }
    }

    var onDrop = function (source, target) {
        // see if the move is legal
        var move = game.move({
            from: source,
            to: target,
            promotion: 'q' // NOTE: always promote to a queen for example simplicity
        });

        // illegal move
        if (move === null) {
            removeGreySquares();
            return 'snapback';
        }

        onLastMoveRemoveHighlight();

        lastMoveDetail.push(source);
        lastMoveDetail.push(target);

        lastMoved = source + "-" + target;
        onLastMoveAddHighlight();

        canUpdate = true;
        updateStatus(move);
    };

    var onMouseoverSquare = function (square, piece) {
        if (piece == false || piece.indexOf(dontTouchPiece) === 0 || dontTouchPiece === 'YES')
            return false;

        // get list of possible moves for this square
        var moves = game.moves({
            square: square,
            verbose: true
        });

        // exit if there are no moves available for this square
        if (moves.length === 0) return;

        // highlight the square they moused over
        greySquare(square);

        // highlight the possible squares for this piece
        for (var i = 0; i < moves.length; i++) {
            greySquare(moves[i].to);
        }
    };

    var onMouseoutSquare = function (square, piece) {

        if (piece == false || piece.indexOf(dontTouchPiece) === 0)
            return false;

        removeGreySquares();
    };

    var onSnapEnd = function () {
        board.position(game.fen());
    };

    var updateStatus = function (moveObject) {
        var status = '';
        var curStatus = "*";
        var curStatusMessage = "In Progress";

        var moveColor = 'White';
        if (game.turn() === 'b') {
            moveColor = 'Black';
        }

        // checkmate?
        if (game.in_checkmate() === true) {

            //Update Status
            curStatusMessage = "White Wins";
            curStatus = "1-0";

            if (moveColor == 'White') {
                curStatus = "0-1";
                curStatusMessage = "Black Wins";
            }

            status = 'Game over, ' + moveColor + ' is in checkmate.';
        }

            // draw?
        else if (game.in_draw() === true) {
            curStatusMessage = "Game Drawn";
            curStatus = "1/2-1/2";

            status = 'Game over, Drawn position';
        }

            // game still on
        else {
            status = "Now " + moveColor + "'s turn!";

            // check?
            if (game.in_check() === true) {
                status += ', ' + moveColor + ' is in check';
            }
        }

        // $('#divProgress').html(curStatusMessage);

        var notation = game.fen();
        var pgn = game.pgn();

        var notationSplit = notation.split(/\s+/);

        startNotation = notation;
        startPostition = notationSplit[0];

        if (canUpdate && moveObject != null) {
            canUpdate = false;

            var moveDetail = {
                MoveDetail: notation,
                Result: curStatus,
                LastMovedBy: '',
                BoardId: '',
                LastMove: lastMoved
            };

            if (moveObject.color != null && moveObject.captured != null && moveObject.captured !== 'undefined') {
                if (moveObject.color === 'b')
                    moveDetail.WhiteRemovedPieces = moveObject.captured;
                else if (moveObject.color === 'w')
                    moveDetail.BlackRemovedPieces = moveObject.captured;
            }

            //alert(lastMoveDetail.length);

            if (allowServiceCall) {
                $scope.UpdateMoveDetail(moveDetail);
            }
        }

        //statusEl.html(status);

        //fenEl.html(notation);
        //pgnEl.html(pgn);
    };

    // alert("orientation =" + curOrientation);

    var cfg = {
        draggable: true,
        position: 'start',
        onDragStart: onDragStart,
        onDrop: onDrop,
        onMouseoutSquare: onMouseoutSquare,
        onMouseoverSquare: onMouseoverSquare,
        onSnapEnd: onSnapEnd,
        orientation: curOrientation
    };

    board = ChessBoard('divChessBoard', cfg);

    onLastMoveAddHighlight();
    updateStatus(null);
}

function LoadRemovedPiecesCount(curBoardDetail) {
    if (curBoardDetail != null) {
        var wRCount = 0;
        var wNCount = 0;
        var wBCount = 0;
        var wPCount = 0;
        var wQCount = 0;

        var bRCount = 0;
        var bNCount = 0;
        var bBCount = 0;
        var bPCount = 0;
        var bQCount = 0;

        var curPiece = "";
        if (curBoardDetail.whiteRemovedPieces != null && curBoardDetail.whiteRemovedPieces !== 'undefined' && curBoardDetail.whiteRemovedPieces != "") {
            var wRemovedPieceSplit = curBoardDetail.whiteRemovedPieces.split("-");

            for (var i = 0; i < wRemovedPieceSplit.length; i++) {
                curPiece = wRemovedPieceSplit[i];

                if (curPiece != "") {

                    if (curPiece == "r")
                        wRCount++;
                    else if (curPiece == "n")
                        wNCount++;
                    else if (curPiece == "b")
                        wBCount++;
                    else if (curPiece == "p")
                        wPCount++;
                    else if (curPiece == "q")
                        wQCount++;
                }
            }
        }

        if (curBoardDetail.blackRemovedPieces != null && curBoardDetail.blackRemovedPieces !== 'undefined' && curBoardDetail.blackRemovedPieces != "") {
            var bRemovedPieceSplit = curBoardDetail.blackRemovedPieces.split("-");

            for (var i = 0; i < bRemovedPieceSplit.length; i++) {
                curPiece = bRemovedPieceSplit[i];

                if (curPiece != "") {

                    if (curPiece == "r")
                        bRCount++;
                    else if (curPiece == "n")
                        bNCount++;
                    else if (curPiece == "b")
                        bBCount++;
                    else if (curPiece == "p")
                        bPCount++;
                    else if (curPiece == "q")
                        bQCount++;
                }
            }
        }

        $('#tdwRCount').html(wRCount);
        $('#tdwNCount').html(wNCount);
        $('#tdwBCount').html(wBCount);
        $('#tdwPCount').html(wPCount);
        $('#tdwQCount').html(wQCount);

        $('#tdbRCount').html(bRCount);
        $('#tdbNCount').html(bNCount);
        $('#tdbBCount').html(bBCount);
        $('#tdbPCount').html(bPCount);
        $('#tdbQCount').html(bQCount);
    }
}