﻿app.controller("playerSuggestionCtrl", ['$scope', '$uibModalInstance', 'commonService', 'Session', 'UIService', function ($scope, $uibModalInstance, commonService, Session, UIService) {

    var deviceId = Session.getSession();
    var containerHeight = window.innerHeight - 120;
    $scope.ContainerHeight = containerHeight + "px";
    $scope.redAlert = "";
    $scope.greenAlert = "";

    $scope.DayPerMoveList = [{ "id": 2, "name": "2 days per move" }, { "id": 3, "name": "3 days per move" },
    { "id": 5, "name": "5 days per move" },
    { "id": 8, "name": "1 hour per move" },
    { "id": 9, "name": "30 minutes per move" },
    { "id": 10, "name": "1 minute per move (Rapid)" }
    ];

    $scope.BoardColor = [{ "id": true, "name": "White" }, { "id": false, "name": "Black" }];

    $scope.RequestGame = function (player) {
        $scope.redAlert = "";
        var currentUserId = Session.getSession();
        $scope.redAlert = "";
        $scope.greenAlert = "";
        player.Msg = "";

        if (player != null && currentUserId != "") {
            var whiteColor = player.WhiteBoard;

            //### Start: Automate this
            var daysPerMove = 0; // player.DaysPerMove;
            var hoursPerMove = 0;
            var minutesPerMove = 0;

            if (player.DaysPerMove < 8) {
                daysPerMove = player.DaysPerMove;
            }
            else if (player.DaysPerMove == 8) {
                hoursPerMove = 1;
            }
            else if (player.DaysPerMove == 9) {
                minutesPerMove = 30;
            }
            else if (player.DaysPerMove == 10) {
                minutesPerMove = 1;
            }
            //### End: Automate this

            var currentUserId = Session.getSession();

            var whiteId = "";
            var blackId = "";
            //var startPosition = Session.getStartPosition();
            //var result = "*";
            //var resultDesc = "Pending"; //Pending, Approved, In Progress, Completed

            if (whiteColor == true) {
                whiteId = currentUserId;
                blackId = player.UserId;
            }
            else {
                whiteId = player.UserId;
                blackId = currentUserId;
            }

            var requestInfo = {
                WhiteId: whiteId,
                BlackId: blackId,
                RequestedBy: currentUserId,
                DaysPerMove: daysPerMove,
                HoursPerMove: hoursPerMove,
                MinutesPerMove: minutesPerMove
            };

            //alert(requestInfo);
            //return;

            UIService.showLoader('main');
            var promise = commonService.sendGameRequest(requestInfo);

            promise.then(function (data) {
                UIService.hideLoader('main');
                if (data != null) {
                    if (data.IsSuccess) {
                        //$scope.greenAlert = "Request Sent!";

                        player.Msg = data.Message;
                    }
                    else {
                        player.Msg = data.Message;
                    }
                }
                else {
                    $scope.redAlert = "Please check internet connectivity.";
                }
            });
        }
    }

    $scope.PlayerList = [];

    $scope.loadShowPlayerList = function () {
        $scope.redAlert = "";

        UIService.showLoader('main');
        var promise = commonService.getUsersForMatchRequest(deviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            if (data != null) {
                if (data.IsSuccess) {
                    $scope.PlayerList = data.UserIdNameList;
                    $scope.redAlert = data.Message;
                }
                else {
                    $scope.redAlert = "Please check internet connectivity.";
                    $scope.PlayerList = [];
                }
            }
            else {

                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.loadShowPlayerList();


    //$scope.ok = function () {
    //    alert("Ok");
    //    $uibModalInstance.close("Ok");
    //}

    $scope.cancel = function () {
        //alert("Cancel");
        $uibModalInstance.dismiss();
    }

}]);