﻿app.factory('DBUtil', function ($http) {
    var DBUtil = {
        DbSession: null,
        boardChatMessages: null,
        syncChatMessages: null,
        initializeDbSession: function () {
            try {
                if (DBUtil.DbSession == null)
                    DBUtil.DbSession = window.sqlitePlugin.openDatabase({ name: "ChessConnect.db", location: 'default' });
            } catch (e) {
                alert("EC: 100");
            }

            //alert("DBUtil.DbSession Created");
        },
        createChatDb: function () {

            if (DBUtil.DbSession == null)
                return;

            DBUtil.DbSession.transaction(function (transaction) {
                transaction.executeSql('CREATE TABLE IF NOT EXISTS BoardChatMessageDetail (ChatMessageId integer primary key, LocalChatMessageId varchar(100), SyncChatMessageId varchar(100), SenderId varchar(100),SenderName varchar(25), Message text, BoardId varchar(100), IsDeleted int, SentOn datetime)', [],
                  function (tx, result) {
                      //alert("Chat Table Created");
                  },
                  function (error) {
                      alert("EC: 101");
                  });
            });
        },
        createDynamicId: function () {
            var randomId = (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
            return randomId;
        },
        insertChatDetail: function (chatDetail, callBack) {

            DBUtil.DbSession.transaction(function (transaction) {
                transaction.executeSql('Insert Into BoardChatMessageDetail(LocalChatMessageId,SyncChatMessageId,SenderId,SenderName,Message,BoardId,IsDeleted,SentOn) Values (?,?,?,?,?,?,?,?)',
                       [chatDetail.LocalChatMessageId, '', chatDetail.UserId, chatDetail.SenderName, chatDetail.Message, chatDetail.BoardId, 0, null],
                       function (tx, results) {
                           callBack();
                           //alert("Inserted Chat");
                       },
                       function (error) {

                           //var message = "LCM = " + chatDetail.LocalChatMessageId + "; SyncChatMessageId = " + chatDetail.UserId + "; SenderId =" + chatDetail.UserId + "; SenderName= " + chatDetail.SenderName + "; MSG = " + chatDetail.Message + "; BoardId = " + chatDetail.BoardId;
                           //alert(message);

                           //alert(error);

                           //if (error != null && error.name != null && error.name != undefined) {
                           //    alert("EName = " + error.name);
                           //}

                           //if (error != null && error.message != null && error.message != undefined)
                           //{
                           //    alert("EMessage = " + error.message);
                           //}

                           alert("ECR: 102");
                       });
            });

        },
        getBoardChatMessage: function (chatDetail, callBack) {
            DBUtil.boardChatMessages = [];

            DBUtil.DbSession.transaction(function (transaction) {
                transaction.executeSql('Select * From BoardChatMessageDetail Where BoardId=? And ChatMessageId >? And IsDeleted=? Order by SentOn asc',
                       [chatDetail.BoardId, chatDetail.ChatIndexId, 0],
                       function (tx, results) {

                           var len = results.rows.length, i;
                           //alert("Messages Count From Db: " + len);

                           if (len > 0) {
                               // alert("Priority Length: " + len);
                               for (var i = 0; i < len; i++) {

                                   DBUtil.boardChatMessages.push({
                                       ChatMessageId: results.rows.item(i).ChatMessageId,
                                       SenderId: results.rows.item(i).SenderId,
                                       UserName: results.rows.item(i).SenderName,
                                       Message: results.rows.item(i).Message,
                                       IsCurrentUserMessage: true,
                                       OtherInfo1: '',
                                       SentOn: results.rows.item(i).SentOn
                                   });

                               }
                           }

                           callBack(DBUtil.boardChatMessages);
                           //return DBUtil.boardChatMessages;
                       },
                       function (error) {
                           alert("EC: 103");
                       });
            });

        },
        syncChatDetail: function (requestInfo, callBack) {

            DBUtil.syncChatMessages = [];

            DBUtil.DbSession.transaction(function (transaction) {
                transaction.executeSql('Select * From BoardChatMessageDetail Where SyncChatMessageId=? And SenderId=? Order By ChatMessageId Asc',
                       ['', requestInfo.UserId],
                       function (tx, results) {

                           var len = results.rows.length, i;
                           //alert("Un-SYNC Messages Count: " + len);

                           if (len > 0) {
                               // alert("Priority Length: " + len);
                               for (var i = 0; i < len; i++) {

                                   DBUtil.syncChatMessages.push({
                                       LocalMessageId: results.rows.item(i).ChatMessageId,
                                       LocalChatMessageId: results.rows.item(i).LocalChatMessageId,
                                       ChatMessageId: results.rows.item(i).SyncChatMessageId,
                                       Message: results.rows.item(i).Message,
                                       BoardId: results.rows.item(i).BoardId,
                                       UserId: requestInfo.UserId,
                                       MobileDeviceId: requestInfo.MobileDeviceId,
                                   });

                               }
                           }

                           callBack(requestInfo, DBUtil.syncChatMessages);
                           //return DBUtil.boardChatMessages;
                       },
                       function (error) {
                           alert("EC: 104");
                       });
            });
        },
        updateChatDetailList: function (chatDetailList, newChatDetailList, callBack) {

            if (chatDetailList != null && chatDetailList.length > 0) {
                //alert("UPD Chat LEN:" + chatDetailList.length);
                DBUtil.DbSession.transaction(function (transaction) {
                    for (var i = 0; i < chatDetailList.length; i++) {
                        transaction.executeSql('Update BoardChatMessageDetail Set SyncChatMessageId=?, SentOn=? Where ChatMessageId=? And LocalChatMessageId=?',
                               [chatDetailList[i].ChatMessageId, chatDetailList[i].SentOn, chatDetailList[i].LocalMessageId, chatDetailList[i].LocalChatMessageId],
                               function (tx, results) {
                               },
                               function (error) {
                                   alert("EC: 105");
                               });
                    }
                });
            }

            if (newChatDetailList != null && newChatDetailList.length > 0) {
                //alert("NEW Chat LEN:" + newChatDetailList.length);
                for (var i = 0; i < newChatDetailList.length; i++) {
                    //alert("syncNewMessages: " + newChatDetailList.length);
                    DBUtil.syncNewMessages(newChatDetailList[i]);
                }
            }

            //alert("Filler12");
            callBack(chatDetailList, newChatDetailList);
        },
        syncNewMessages: function (chatDetail) {
            DBUtil.DbSession.transaction(function (transaction) {
                //alert("SYNC Message Id: " + chatDetail.ChatMessageId);
                //alert("Local Message Id: " + chatDetail.LocalMessageId);

                transaction.executeSql('Select * From BoardChatMessageDetail Where SyncChatMessageId=? And SenderId=? And LocalChatMessageId=?',
                      [chatDetail.ChatMessageId, chatDetail.UserId, chatDetail.LocalChatMessageId],
                      function (tx, results) {
                          var len = results.rows.length
                          //alert("Length:" + len);
                          if (len <= 0) {
                              transaction.executeSql('Insert Into BoardChatMessageDetail(LocalChatMessageId,SyncChatMessageId,SenderId,SenderName,Message,BoardId,IsDeleted,SentOn) Values (?,?,?,?,?,?,?,?)',
                              [chatDetail.LocalChatMessageId, chatDetail.ChatMessageId, chatDetail.UserId, chatDetail.UserName, chatDetail.Message, chatDetail.BoardId, 0, chatDetail.SentOn],
                              function (tx, results) {
                                  //alert("New Message Added..");
                              },
                              function (error) {
                                  //alert("Error");
                              });
                          }
                      },
                    function (error) {
                        alert("EC: 106");
                    });

            });
        }
    };

    // Call Local DB and Get the Info.

    return DBUtil;
});

app.controller("chatCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', 'DBUtil', function ($scope, commonService, Session, UIService, $interval, DBUtil) {
    //SQLLite DB Connection
    if (isAndroidApp) {
        //Start: Initialize DB Session
        DBUtil.initializeDbSession();
        DBUtil.createChatDb();
        //End: Initialize DB Session
    }

    var deviceId = Session.getSession();
    var mobileDeviceId = Session.getMobileDeviceId();
    var boardId = Session.getBoardId();
    var chatIndexId = 0;

    if (deviceId == "" || mobileDeviceId == "") {
        location.href = "#/login";
        return;
    }

    if (boardId == "") {
        location.href = "#/mygamelist";
        return;
    }

    $scope.redAlert = "";
    var isInServiceCall = false;
    var isMsgSyncInProgress = false;

    $scope.MessageSection = { "Message": "" };

    $scope.MessageList = [];

    //$scope.MessageList = [{ "SentBy": "Rajkumar", "Message": "<<This is Text message 1", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "<ssdsd>asdasdsd<asdasd>This is Text message 2 This is Text message 2 This is Text message 2 This is Text message 2 This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" },
    //    { "SentBy": "Rajkumar", "Message": "This is Text message 2", "SentOn": "09-09-8902" }
    //];

    // Start: SYNC Message Region
    $scope.RefreshLoadedMessages = function (chatDetailList, newChatDetailList) {
        if ((chatDetailList != null && chatDetailList.length > 0) || (newChatDetailList != null && newChatDetailList.length > 0)) {
            //alert("Execute Callback to Refresh:" + newChatDetailList.length);
            // alert("New Refresh");

            chatIndexId = 0;
            $scope.GetMessage();
        }
    };

    $scope.SyncMessageForDeviceCallBack = function (requestInfo, unSyncMessageList) {

        //alert(isMsgSyncInProgress);
        if (isMsgSyncInProgress == true)
            return;

        if (unSyncMessageList != null) {
            //alert("Unsync Message Count: " + unSyncMessageList.length);

            //Step 1: Send Messages To Server And Get New Messages for this user id.
            //Step 2: Update ChatId and Sent On in Local Db
            //Step 3: Insert New Messages for the current User
            //Step 3: Refresh Message Section

            isMsgSyncInProgress = true;

            try {
                var promise = commonService.syncMessage(requestInfo, unSyncMessageList);

                promise.then(function (data) {
                    isMsgSyncInProgress = false;

                    if (data != null) {
                        if (data.IsSuccess) {

                            //alert("Success");
                            //if (data.SubmittedMessageDetailList != null)
                            //    alert("Sent Messages To Server Count: " + data.SubmittedMessageDetailList.length);

                            DBUtil.updateChatDetailList(data.SubmittedMessageDetailList, data.NewMessageDetailList, $scope.RefreshLoadedMessages);
                        }
                        else {
                            //alert("Not submitted");
                        }
                    }
                    else {
                        //alert("Check Network");
                    }
                });

            } catch (e) {
                isMsgSyncInProgress = false;
            }

        }
        //else
        //    alert("No SYNC Messages");
    };

    //*** ONLINE SYNC
    $scope.SyncMessageForDevice = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();

        var requestInfo = {
            UserId: "",
            MobileDeviceId: ""
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(deviceId, 3);
        requestInfo.UserId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(mobileDeviceId, 3);
        requestInfo.MobileDeviceId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        DBUtil.syncChatDetail(requestInfo, $scope.SyncMessageForDeviceCallBack);
    };
    // End: SYNC Message Region

    // Start: Get Message Region

    $scope.GetMessageForDeviceCallBack = function (getMessages) {
        //alert("getMessage LENGTH: " + getMessages.length);
        if (getMessages != null && getMessages.length > 0) {
            var len = getMessages.length;
            //alert("Chat Message Present. Length " + len);

            var encMsg = "";
            var decMsg = "";

            var decUserId = "";
            var userName = "";

            //alert("chatIndexId: " + chatIndexId);
            if (chatIndexId == 0) {
                $scope.$apply(function () {
                    $scope.MessageList = [];
                    $scope.MessageList.length = 0;
                });
            }

            for (var i = 0; i < getMessages.length; i++) {

                encMsg = getMessages[i].Message;
                decMsg = DecryptCipherTextToPlainText(encMsg, 3);
                getMessages[i].Message = decMsg;

                decUserId = getMessages[i].SenderId;
                decUserId = DecryptCipherTextToPlainText(decUserId, 3);

                getMessages[i].IsCurrentUserMessage = false;
                getMessages[i].OtherInfo1 = "text-align:left;float:left;";

                if (deviceId == decUserId) {
                    getMessages[i].UserName = "Me";
                    getMessages[i].IsCurrentUserMessage = true;
                    getMessages[i].OtherInfo1 = "text-align:right;float:right;background-color:#f5f5f5;border-radius:5px";
                }
                else {
                    userName = getMessages[i].UserName;
                    userName = DecryptCipherTextToPlainText(userName, 3);
                    getMessages[i].UserName = userName;
                }


                if (getMessages[i].IsCurrentUserMessage && getMessages[i].SentOn == null) {
                    getMessages[i].SentOn = "Not Delivered";
                }

                $scope.$apply(function () {
                    chatIndexId = getMessages[i].ChatMessageId;
                    $scope.MessageList.push(getMessages[i]);
                });
            }

            //$scope.$apply();

            //alert("MessageList LEN: " + $scope.MessageList.length);

            $("#msgList").animate({ scrollTop: $('#msgList').prop("scrollHeight") }, 2000);
        }
        //else {
        //    $scope.$apply(function () {
        //        $scope.redAlert = "No New Messages!";
        //    });
        //}
    };

    $scope.GetMessageForDevice = function (cId) {

        var requestInfo = {
            BoardId: "",
            ChatIndexId: 0,
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(boardId, 3);
        requestInfo.BoardId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        requestInfo.ChatIndexId = cId;
        DBUtil.getBoardChatMessage(requestInfo, $scope.GetMessageForDeviceCallBack);
    };

    $scope.GetMessage = function () {

        if (isAndroidApp) {
            //Start: Get Message From Local DB
            $scope.GetMessageForDevice(chatIndexId);
            return;
            //End: Get Message From Local DB
        }

        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        boardId = Session.getBoardId();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
            return;
        }

        var requestInfo = {
            BoardId: "",
            UserId: "",
            MobileDeviceId: ""
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(boardId, 3);
        requestInfo.BoardId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(deviceId, 3);
        requestInfo.UserId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(mobileDeviceId, 3);
        requestInfo.MobileDeviceId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        isInServiceCall = true;
        //$scope.redAlert = "";

        UIService.showLoader('main');
        var promise = commonService.getMessage(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    //$scope.redAlert = data.Message;
                    $scope.MessageList = [];// = data.ChatMessageDetailList;

                    var decMsg = "";
                    var decUserId = "";
                    var decUserName = "";

                    if (data.ChatMessageDetailList != null && data.ChatMessageDetailList.length > 0) {
                        for (var i = 0; i < data.ChatMessageDetailList.length; i++) {

                            decMsg = DecryptCipherTextToPlainText(data.ChatMessageDetailList[i].Message, 3);
                            data.ChatMessageDetailList[i].Message = decMsg;

                            decUserId = DecryptCipherTextToPlainText(data.ChatMessageDetailList[i].UserId, 3);
                            data.ChatMessageDetailList[i].UserId = decUserId;

                            data.ChatMessageDetailList[i].OtherInfo1 = "text-align:left;float:left;";
                            if (deviceId == decUserId) {
                                data.ChatMessageDetailList[i].UserName = "Me";
                                data.ChatMessageDetailList[i].OtherInfo1 = "text-align:right;float:right;background-color:#f5f5f5;border-radius:5px";
                            }
                            else {
                                decUserName = DecryptCipherTextToPlainText(data.ChatMessageDetailList[i].UserName, 3);
                                data.ChatMessageDetailList[i].UserName = decUserName;
                            }

                            $scope.MessageList.push(data.ChatMessageDetailList[i]);
                        }
                    }

                    $("#msgList").animate({ scrollTop: $('#msgList').prop("scrollHeight") }, 2000);
                }
                else {
                    $scope.redAlert = data.Message;
                    $scope.MessageList = [];
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });

    };

    $scope.GetMessage();

    if (isAndroidApp) {
        $scope.SyncMessageForDevice();
    }
    // End: Get Message Region

    //Start: Send Message Region
    $scope.SendMessageForDeviceCallBack = function () {

        $scope.$apply(function () {
            $scope.redAlert = "Message sent!";
        });

        $scope.GetMessage();
        $scope.SyncMessageForDevice();
    };

    $scope.GetRandomId = function () {
        var randomId = (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        return randomId;
    };

    $scope.SendMessage = function () {

        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        boardId = Session.getBoardId();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
            return;
        }

        if ($scope.MessageSection.Message == "") {
            $scope.redAlert = "Please enter Message.";
            return;
        }
        
        //alert("deviceId = " + deviceId);
        //alert("mobileDeviceId = " + mobileDeviceId);
        var localChatMessageId = ($scope.GetRandomId() + $scope.GetRandomId() + "-" + $scope.GetRandomId() + "-4" + $scope.GetRandomId().substr(0, 3) + "-" + $scope.GetRandomId() + "-" + $scope.GetRandomId() + $scope.GetRandomId() + $scope.GetRandomId()).toLowerCase();
        //alert("randomId = " + localChatMessageId);
        //return;

        var requestInfo = {
            LocalChatMessageId: localChatMessageId,
            Message: "",
            BoardId: "",
            UserId: "",
            MobileDeviceId: "",
            SenderName: ""
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText($scope.MessageSection.Message, 3);
        requestInfo.Message = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(boardId, 3);
        requestInfo.BoardId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(deviceId, 3);
        requestInfo.UserId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(mobileDeviceId, 3);
        requestInfo.MobileDeviceId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(Session.getUserName(), 3);
        requestInfo.SenderName = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        //Send Only To Local DB For android App.
        if (isAndroidApp) {
            //Start: Submit Chat Detail
            $scope.MessageSection.Message = "";
            DBUtil.insertChatDetail(requestInfo, $scope.SendMessageForDeviceCallBack);
            return;
            //End: Submit Chat Detail
        }

        isInServiceCall = true;
        $scope.redAlert = "";

        //var arrayMessageList = [];
        //arrayMessageList.push({
        //    LocalMessageId: 1,
        //    ChatMessageId: '',
        //    Message: requestInfo.Message,
        //    BoardId: requestInfo.BoardId,
        //    UserId: requestInfo.UserId,
        //    MobileDeviceId: requestInfo.MobileDeviceId,
        //});

        //arrayMessageList.push({
        //    LocalMessageId: 2,
        //    ChatMessageId: '',
        //    Message: requestInfo.Message,
        //    BoardId: requestInfo.BoardId,
        //    UserId: requestInfo.UserId,
        //    MobileDeviceId: requestInfo.MobileDeviceId,
        //});

        UIService.showLoader('main');
        var promise = commonService.sendMessage(requestInfo);
        //var promise = commonService.syncMessage(requestInfo, arrayMessageList);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.MessageSection.Message = "";

                    $scope.redAlert = data.Message;

                    $scope.GetMessage();
                }
                else {
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });

    };
    //End: Send Message Region

    $scope.goToBoard = function () {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        boardId = Session.getBoardId();

        if (boardId == "") {
            location.href = "#/mygamelist";
            return;
        }

        location.href = "#/board";
    };

    $scope.refresh = function () {
        if (!isInServiceCall) {
            $scope.GetMessage();
        }
    };

    $scope.AutoMessageRefresh = function () {

        if (isAndroidApp) {
            $scope.SyncMessageForDevice();
        }
        else {
            $scope.GetMessage();
        }
    }

    var autoMessageRefreshAction = $interval($scope.AutoMessageRefresh, chatMsgRefreshInMs);

    $scope.$on("$destroy", function () {
        if (autoRefreshAction != null) {
            $interval.cancel(autoMessageRefreshAction);
        }
    });

}]);