﻿app.controller("confirmCtrl", ['$scope', 'commonService', 'Session', 'UIService', function ($scope, commonService, Session, UIService) {

    var deviceId = Session.getTempUid();
    var mobileDeviceId = Session.getTempMid();
    var nextCode = Session.getNextCode();

    if (deviceId == "" || mobileDeviceId == "") {
        location.href = "#/login";
        return;
    }

    $scope.Title = "";
    $scope.Messsage = "";
    $scope.ContinueValue = "";
    $scope.ShowNextButton = false;
    $scope.ShowRetryButton = false;
    $scope.redAlert = "";

    document.getElementById("btnContinue").style.display = "none";
    document.getElementById("btnRetry").style.display = "none";

    $scope.Control = { "ShowNextButton": false, "ShowRetryButton": false };

    var isInServiceCall = false;

    $scope.GetNextMessage = function () {

        deviceId = Session.getTempUid();
        mobileDeviceId = Session.getTempMid();
        nextCode = Session.getNextCode();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        var requestInfo = {
            UserId: "",
            MobileDeviceId: "",
            NextCode: ""
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(nextCode, 3);
        requestInfo.NextCode = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(deviceId, 3);
        requestInfo.UserId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(mobileDeviceId, 3);
        requestInfo.MobileDeviceId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("btnContinue").style.display = "none";
        document.getElementById("btnRetry").style.display = "none";

        isInServiceCall = true;
        $scope.redAlert = "";

        UIService.showLoader('main');
        var promise = commonService.getNextConfirmationDetail(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.ContinueDetail != null) {
                    var continueDetail = data.ContinueDetail;

                    $scope.Title = continueDetail.Title;
                    $scope.Messsage = continueDetail.MessageToUser;
                    $scope.ContinueValue = continueDetail.ContinueValue;

                    document.getElementById("btnContinue").style.display = "block";
                }
                else {
                    $scope.redAlert = data.Message;

                    document.getElementById("btnRetry").style.display = "block";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
                document.getElementById("btnRetry").style.display = "block";
            }
        });
    };

    $scope.GetNextMessage();

    $scope.AgreeAndContinue = function () {

        deviceId = Session.getTempUid();
        mobileDeviceId = Session.getTempMid();
        nextCode = Session.getNextCode();
        var tempName = Session.getTempUserName();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        var requestInfo = {
            UserId: "",
            MobileDeviceId: "",
            NextCode: ""
        };

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(nextCode, 3);
        requestInfo.NextCode = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(deviceId, 3);
        requestInfo.UserId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        document.getElementById("hdnMessage").value = EncryptPlainTextToCipherText(mobileDeviceId, 3);
        requestInfo.MobileDeviceId = document.getElementById("hdnMessage").value;
        document.getElementById("hdnMessage").value = "";

        //document.getElementById("btnContinue").style.display = "none";
        document.getElementById("btnRetry").style.display = "none";

        isInServiceCall = true;
        $scope.redAlert = "";

        UIService.showLoader('main');
        var promise = commonService.confirmAndGoNext(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.Message == "PROCEED") {
                    Session.updateSession(deviceId);
                    Session.setUserName(tempName);

                    Session.afterLogin();

                    location.href = "#/mygamelist";
                }
                else {
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    };
}]);