﻿"use strict"
var app = angular.module("bApp");

var chatMsgRefreshInMs = 20000;
var boardRefreshInMs = 20000;
var messageRefreshInMs = 20000;
var messageRefreshImmediate = 4000;
//alert(serviceUrl);

app.factory('Session', function ($http) {
    var Session = {
        tempDeviceId: "",
        tempMobileDeviceId: "",
        tempNextCode: "",
        tempUserName: "",
        deviceId: "",
        userName: "",
        boardId: "",
        boardDetail: null,
        viewOption: 1,
        filterGameOption: 0,
        startPosition: "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1",
        tournamentId: "",
        mobileDeviceId: "",
        tournamentRound: 1,
        tournamentRoundStatus: 0,
        saveSession: function () { /* save session data to db */ },
        updateSession: function (userId) {
            Session.deviceId = userId;
        },
        getSession: function () {
            return Session.deviceId;
        },
        getStartPosition: function () {
            return Session.startPosition;
        },
        setBoardId: function (bId) {
            Session.boardId = bId;
        },
        getBoardId: function () {
            return Session.boardId;
        },
        setBoardDetail: function (bDetail) {
            Session.boardDetail = bDetail;
        },
        getBoardDetail: function () {
            return Session.boardDetail;
        },
        setUserName: function (uName) {
            Session.userName = uName;
        },
        getUserName: function () {
            return Session.userName;
        },
        setViewOption: function (option) {
            Session.viewOption = option;
        },
        getViewOption: function () {
            return Session.viewOption;
        },
        setFilterGameOption: function (option) {
            Session.filterGameOption = option;
        },
        getFilterGameOption: function () {
            return Session.filterGameOption;
        },
        setTournamentId: function (tId) {
            Session.tournamentId = tId;
        },
        getTournamentId: function () {
            return Session.tournamentId;
        },
        setMobileDeviceId: function (mId) {
            Session.mobileDeviceId = mId;
        },
        getMobileDeviceId: function () {
            return Session.mobileDeviceId;
        },
        setTournamentRound: function (round) {
            Session.tournamentRound = round;
        },
        getTournamentRound: function () {
            return Session.tournamentRound;
        },
        setTournamentRoundStatus: function (roundStatus) {
            Session.tournamentRoundStatus = roundStatus;
        },
        getTournamentRoundStatus: function () {
            return Session.tournamentRoundStatus;
        },
        setTempDetail: function (uId, mId, nCode, tName) {
            Session.tempDeviceId = uId;
            Session.tempMobileDeviceId = mId;
            Session.tempNextCode = nCode;
            Session.tempUserName = tName;
        },
        getTempUid: function () {
            return Session.tempDeviceId;
        },
        getTempMid: function () {
            return Session.tempMobileDeviceId;
        },
        getNextCode: function () {
            return Session.tempNextCode;
        },
        getTempUserName: function () {
            return Session.tempUserName;
        },
        afterLogin: function () {
            //if (document.getElementById("divUserStatistics") != null && document.getElementById("divUserStatistics") != undefined) {
            //    document.getElementById("divUserStatistics").style.display = "block";
            //    document.getElementById("divUserStatistics1").style.display = "block";
            //}

            if (document.getElementById("divNavigationBar") != null && document.getElementById("divNavigationBar") != undefined) {
                document.getElementById("btnMenu").style.display = "block";
                document.getElementById("divNavigationBar").style.display = "block";
            }
        }
    };

    // Call Local DB and Get the Info.

    return Session;
});

/* Controllers  */

app.controller('menuCtrl', ['$scope', '$route', '$routeParams', '$location', '$timeout', 'commonService', 'Session', function ($scope, $route, $routeParams, $location, $timeout, commonService, Session) {
    $scope.$route = $route;
    $scope.$location = $location;
    $scope.$routeParams = $routeParams;

    document.getElementById("divAlertImage1").style.display = "none";
    document.getElementById("divAlertImageContent1").style.display = "none";

    document.getElementById("divAlertImage").style.display = "none";
    document.getElementById("divAlertImageContent").style.display = "none";

    document.getElementById("divOfflineUsers").style.display = "none";
    document.getElementById("divOnlineUsers").style.display = "none";
    document.getElementById("divOnlineUsersCount").style.display = "none";

    document.getElementById("divOfflineUsers1").style.display = "none";
    document.getElementById("divOnlineUsers1").style.display = "none";
    document.getElementById("divOnlineUsersCount1").style.display = "none";

    document.getElementById("divNavigationBar").style.display = "none";
    document.getElementById("btnMenu").style.display = "none";

    $scope.ShowMatchCount = false;
    $scope.MatchCount = 0;
    $scope.OnlineUserCount = 0;
    $scope.NotificationCount = 0;
    $scope.PreviousMatchCount = 0;
    $scope.NotificationId = 0;

    var showAlertControl = function (ctrlId) {
        if (ctrlId == 1) {
            if (document.getElementById("divAlertImage1") != null) {
                document.getElementById("divAlertImage1").style.display = "block";
                document.getElementById("divAlertImageContent1").style.display = "block";
            }

            if (document.getElementById("divAlertImage") != null) {
                document.getElementById("divAlertImage").style.display = "block";
                document.getElementById("divAlertImageContent").style.display = "block";
            }
        }
        else if (ctrlId == 2) {

            if (document.getElementById("divOnlineUsers") != null) {
                document.getElementById("divOnlineUsers").style.display = "block";
            }

            if (document.getElementById("divOnlineUsersCount") != null) {
                document.getElementById("divOnlineUsersCount").style.display = "block";
            }

            if (document.getElementById("divOnlineUsers1") != null) {
                document.getElementById("divOnlineUsers1").style.display = "block";
            }

            if (document.getElementById("divOnlineUsersCount1") != null) {
                document.getElementById("divOnlineUsersCount1").style.display = "block";
            }

            if (document.getElementById("divOfflineUsers") != null) {
                document.getElementById("divOfflineUsers").style.display = "none";
            }

            if (document.getElementById("divOfflineUsers1") != null) {
                document.getElementById("divOfflineUsers1").style.display = "none";
            }
        }
        else if (ctrlId == 3) {
            if (document.getElementById("divNotification") != null) {
                document.getElementById("divNotification").style.display = "block";
            }

            if (document.getElementById("divNotification1") != null) {
                document.getElementById("divNotification1").style.display = "block";
            }

            if (document.getElementById("divNotificationContent") != null) {
                document.getElementById("divNotificationContent").style.display = "block";
            }

            if (document.getElementById("divNotificationContent1") != null) {
                document.getElementById("divNotificationContent1").style.display = "block";
            }
        }
    }

    var hideAlertControl = function (ctrlId) {

        if (ctrlId == 1) {
            if (document.getElementById("divAlertImage1") != null) {
                document.getElementById("divAlertImage1").style.display = "none";
                document.getElementById("divAlertImageContent1").style.display = "none";
            }

            if (document.getElementById("divAlertImage") != null) {
                document.getElementById("divAlertImage").style.display = "none";
                document.getElementById("divAlertImageContent").style.display = "none";
            }
        }
        else if (ctrlId == 2) {
            if (document.getElementById("divOnlineUsers") != null) {
                document.getElementById("divOnlineUsers").style.display = "none";
            }

            if (document.getElementById("divOnlineUsersCount") != null) {
                document.getElementById("divOnlineUsersCount").style.display = "none";
            }

            if (document.getElementById("divOnlineUsers1") != null) {
                document.getElementById("divOnlineUsers1").style.display = "none";
            }

            if (document.getElementById("divOnlineUsersCount1") != null) {
                document.getElementById("divOnlineUsersCount1").style.display = "none";
            }

            if (document.getElementById("divOfflineUsers") != null) {
                document.getElementById("divOfflineUsers").style.display = "block";
            }

            if (document.getElementById("divOfflineUsers1") != null) {
                document.getElementById("divOfflineUsers1").style.display = "block";
            }
        }
        else if (ctrlId == 3) {

            if (document.getElementById("divNotification") != null) {
                document.getElementById("divNotification").style.display = "block";
            }

            if (document.getElementById("divNotification1") != null) {
                document.getElementById("divNotification1").style.display = "block";
            }

            if (document.getElementById("divNotificationContent") != null) {
                document.getElementById("divNotificationContent").style.display = "none";
            }

            if (document.getElementById("divNotificationContent1") != null) {
                document.getElementById("divNotificationContent1").style.display = "none";
            }
        }
    }

    $scope.goToGameList = function () {
        location.href = "#/mygamelist";
    }

    $scope.goToPlayerList = function () {
        $("body").removeClass("menu-on");
        location.href = "#/playerlist";
    }

    $scope.goToMyGameList = function () {
        location.href = "#/mygamelist";
    }

    var pushLocalNotification = function (matchCount) {

        if ($scope.NotificationId == 0) {
            $scope.NotificationId = 1;

            cordova.plugins.notification.local.schedule({
                id: $scope.NotificationId,
                at: new Date(new Date().getTime() + 3 * 1000),
                text: matchCount + ' Opponent(s) waiting for your move!',
                title: 'Chess Connect',
                sound: null,
                badge: 1
            });
        }
        else if ($scope.NotificationId == 1) {
            cordova.plugins.notification.local.update({
                id: $scope.NotificationId,
                at: new Date(new Date().getTime() + 3 * 1000),
                text: matchCount + ' Opponent(s) waiting for your move!',
                title: 'Chess Connect',
                sound: null,
                badge: 1
            });
        }


        //var options = {
        //    id: String,  // A unique id of the notification, best to use a numeric value
        //    at: Date,    // This expects a date object
        //    text: String,  // The message
        //    title: String,  // The title of the message
        //    every: String,  // 'minute', 'hour', 'day', 'week', 'month', 'year'
        //    badge: Number,  // Displays a numerical badge
        //    sound: String,  // The sound to be played (null means no sound)
        //    json: String,  // Data to be passed through the notification to your app
        //    autoClear: Boolean, // The notification is canceled when the user clicks it
        //    ongoing: Boolean, // Prevent clearing the notification (Android only)
        //};

        //cordova.plugins.notification.local.schedule(options);
    }

    var countUp = function () {

        $timeout(countUp, messageRefreshInMs);

        var deviceId = Session.getSession();

        if (deviceId == "") {
            return;
        }

        var promise = commonService.getMatchCount(deviceId);

        promise.then(function (data) {

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.MatchCount = data.DeviceIdTurnCount;
                    $scope.OnlineUserCount = data.UserOnlineCount;
                    $scope.NotificationCount = data.NotificationCount;

                    if ($scope.MatchCount != null && $scope.MatchCount > 0) {
                        showAlertControl(1);

                        //if (isAndroidApp && $scope.PreviousMatchCount != $scope.MatchCount) {
                        //    $scope.PreviousMatchCount = $scope.MatchCount;
                        //    pushLocalNotification($scope.MatchCount);
                        //}
                    }
                    else {
                        hideAlertControl(1);
                    }

                    if ($scope.OnlineUserCount != null && $scope.OnlineUserCount > 0) {
                        showAlertControl(2);
                    }
                    else {
                        hideAlertControl(2);
                    }

                    if ($scope.NotificationCount != null && $scope.NotificationCount > 0) {
                        showAlertControl(3);
                    }
                    else {
                        hideAlertControl(3);
                    }

                    if (document.getElementById("divMatchRequestCount") != null && data.MatchRequestCount != null) {
                        document.getElementById("divMatchRequestCount").innerHTML = data.MatchRequestCount;
                    }

                }
                else {
                    hideAlertControl(1);
                    hideAlertControl(2);
                    hideAlertControl(3);

                    if (document.getElementById("divMatchRequestCount") != null) {
                        document.getElementById("divMatchRequestCount").innerHTML = "0";
                    }
                }
            }
            else {
                hideAlertControl(1);
                hideAlertControl(2);
                hideAlertControl(3);
            }
        });
    }

    $timeout(countUp, messageRefreshImmediate);
}]);

app.controller('LoadingPageCtrl', ['$scope', 'commonService', 'Session', 'UIService', function ($scope, commonService, Session, UIService) {
    UIService.showLoader('main');
    if (!isAndroidApp) {
        location.href = "#/privacyAgree";
        //location.href = "#/login";
    }
}]);

app.controller("LoginCtrl", ['$scope', 'commonService', 'Session', 'UIService', function ($scope, commonService, Session, UIService) {
    $scope.txtUserName = "";
    $scope.txtPassword = "";
    $scope.txtConfirmPassword = "";

    $scope.showRegistration = "none";
    $scope.showLogin = "none";
    $scope.showAlreadyLogin = "none";
    $scope.showOutOfDateApp = "none";

    $scope.OutOfDateMessage = "";
    $scope.mobileDeviceId = "";
    $scope.fireBaseId = "";

    var chessDb = null;
    var isUserValuePresentInDb = false;
    var isDeviceIdPresentInDb = false;

    $scope.pushObject = null;

    if (isAndroidApp) {

        if (device != null) {
            $scope.mobileDeviceId = device.uuid;
            Session.setMobileDeviceId(device.uuid);
        }

        $scope.pushObject = PushNotification.init({
            android: {}
        });
    }

    $scope.toggleSignupLogin = function (selectedOption, canApply, msg) {

        if (canApply == 1) {
            $scope.$apply(function () {
                if (selectedOption != 4)
                    $scope.redAlert = msg;

                if (selectedOption == 1) {
                    $scope.showRegistration = "block";
                    $scope.showLogin = "none";
                    $scope.showAlreadyLogin = "none";
                    $scope.showOutOfDateApp = "none";
                }
                else if (selectedOption == 2) {
                    $scope.showRegistration = "none";
                    $scope.showLogin = "block";
                    $scope.showAlreadyLogin = "none";
                    $scope.showOutOfDateApp = "none";
                }
                else if (selectedOption == 3) {
                    $scope.showRegistration = "none";
                    $scope.showLogin = "none";
                    $scope.showAlreadyLogin = "block";
                    $scope.showOutOfDateApp = "none";
                }
                else if (selectedOption == 4) {
                    $scope.showRegistration = "none";
                    $scope.showLogin = "none";
                    $scope.showAlreadyLogin = "none";
                    $scope.showOutOfDateApp = "block";

                    $scope.OutOfDateMessage = msg;
                }
            });
        }
        else {

            if (selectedOption != 4)
                $scope.redAlert = msg;

            if (selectedOption == 1) {
                $scope.showRegistration = "block";
                $scope.showLogin = "none";
                $scope.showAlreadyLogin = "none";
                $scope.showOutOfDateApp = "none";
            }
            else if (selectedOption == 2) {
                $scope.showRegistration = "none";
                $scope.showLogin = "block";
                $scope.showAlreadyLogin = "none";
                $scope.showOutOfDateApp = "none";
            }
            else if (selectedOption == 3) {
                $scope.showRegistration = "none";
                $scope.showLogin = "none";
                $scope.showAlreadyLogin = "block";
                $scope.showOutOfDateApp = "none";
            }
            else if (selectedOption == 4) {
                $scope.showRegistration = "none";
                $scope.showLogin = "none";
                $scope.showAlreadyLogin = "none";
                $scope.showOutOfDateApp = "block";

                $scope.OutOfDateMessage = msg;
            }
        }
    }

    if (window == null) {
        alert("Window is null");
        return;
    }

    try {
        if (isAndroidApp) {
            chessDb = window.sqlitePlugin.openDatabase({ name: "ChessConnect.db", location: 'default' });
            //alert("Created Chess DB")
        }
        //else {
        //    chessDb = window.openDatabase('ChessConnect', "0.1", "ChessConnect", 200000);
        //    //alert("WEB SQL = Created Chess DB");
        //}
    }
    catch (e) {
        alert(e);
    }

    var refreshFirebaseToken = function (isMobileDeviceIdCheck) {
        try {

            $scope.pushObject.on('registration', function (data) {
                $scope.$apply(function () {
                    $scope.fireBaseId = data.registrationId;
                });

                $scope.DoLoginProcess();

            });
        } catch (e) {
            $scope.fireBaseId = "";
            $scope.DoLoginProcess();
        }
    }

    var getFirebaseToken = function (isMobileDeviceIdCheck) {
        $scope.fireBaseId = "";
        try {
            refreshFirebaseToken(isMobileDeviceIdCheck);
        } catch (e) {
            $scope.fireBaseId = "";
            $scope.DoLoginProcess();
        }
    }

    $scope.goToGameList = function () {
        location.href = "#/mygamelist";
    }

    $scope.goToAppStore = function () {
        if (isAndroidApp) {
            window.location.replace('market://details?id=com.developerin.ChessConnect');
        }
        else {
            alert("Please use Android Mobile to use this functionality");
        }
    }

    $scope.doLoginFunction = function (isMobileDeviceIdCheck) {
        var userName = "";
        var password = "";
        var mobileDeviceId = "";
        var fireBaseId = "";

        if ($scope.txtUserName != "") {
            document.getElementById("hdnUserName").value = EncryptPlainTextToCipherText($scope.txtUserName, 1);
            userName = document.getElementById("hdnUserName").value;
        }

        if ($scope.txtPassword != "") {
            document.getElementById("hdnPassword").value = EncryptPlainTextToCipherText($scope.txtPassword, 1);
            password = document.getElementById("hdnPassword").value;
        }

        if ($scope.mobileDeviceId != "") {
            document.getElementById("hdnMobileDeviceId").value = EncryptPlainTextToCipherText($scope.mobileDeviceId, 1);
            mobileDeviceId = document.getElementById("hdnMobileDeviceId").value;
        }

        if ($scope.fireBaseId != "") {
            document.getElementById("hdnFirebaseId").value = EncryptPlainTextToCipherText($scope.fireBaseId, 1);
            fireBaseId = document.getElementById("hdnFirebaseId").value;
        }

        UIService.showLoader('main');
        //var promise = commonService.doLogin($scope.txtUserName, $scope.txtPassword, $scope.mobileDeviceId, $scope.fireBaseId, isMobileDeviceIdCheck);
        var promise = commonService.doLogin(userName, password, mobileDeviceId, fireBaseId, isMobileDeviceIdCheck);

        promise.then(function (data) {
            // Diaglog Close.
            UIService.hideLoader('main');

            if (data != null) {
                //alert("Login Function if");

                if (data.IsSuccess && data.UserDetail != null
                    && data.UserDetail.UserId != "" && data.UserDetail.UserName != "") {
                    // Message to User.
                    // alert(data.IsSuccess);

                    // Check Old Version Code is present or not.
                    // Check Next Code Is Present Or Not. If Present, Show and Proceed.

                    if (!isUserValuePresentInDb && $scope.txtUserName != "" && $scope.txtPassword != "") {
                        data.UserDetail.UserName = $scope.txtUserName;
                        data.UserDetail.Password = $scope.txtPassword;
                    }

                    $scope.doInsertIntoLocalDb(data.UserDetail.UserName, data.UserDetail.Password, data.UserDetail.UserId, $scope.mobileDeviceId, $scope.fireBaseId);

                    if (data.UserDetail.IsConfirmationNeeded && data.ErrorCode != "") {
                        Session.setTempDetail(data.UserDetail.UserId, $scope.mobileDeviceId, data.ErrorCode);
                        location.href = "#/confirm";
                    }
                    else {
                        //Session.setMobileDeviceId("8a1e61e3104571c0");//raj
                        Session.updateSession(data.UserDetail.UserId);
                        Session.setUserName(data.UserDetail.UserName);
                        Session.afterLogin();

                        if (data.OldVersionMessage !== 'undefined' && data.OldVersionMessage != null && data.OldVersionMessage != "") {
                            $scope.toggleSignupLogin(4, 0, data.OldVersionMessage);
                        }
                        else {
                            location.href = "#/mygamelist";
                        }
                    }
                }
                else if (!data.IsSuccess && (isUserValuePresentInDb || isDeviceIdPresentInDb)) {
                    $scope.toggleSignupLogin(3, 0, data.Message);
                }
                else if (!data.IsSuccess && !isDeviceIdPresentInDb && isMobileDeviceIdCheck) {
                    $scope.toggleSignupLogin(2, 0, "");
                }
                else {
                    $scope.toggleSignupLogin(2, 0, data.Message);
                }
            }
            else {
                //alert("Login Function else");
                if (isUserValuePresentInDb || isDeviceIdPresentInDb) {
                    $scope.toggleSignupLogin(3, 0, "Please check Network Connectivity.");
                }
                else {

                    //alert("Login Function else else");
                    $scope.toggleSignupLogin(2, 0, "Please check Network Connectivity.");
                }
            }
        });
    }

    $scope.doLogin = function () {
        $scope.redAlert = "";
        $scope.greenAlert = "";

        if ($scope.txtUserName == null || $scope.txtUserName == "") {
            $scope.redAlert = "Please enter username.";
            return;
        }

        if ($scope.txtPassword == null || $scope.txtPassword == "") {
            $scope.redAlert = "Please enter password.";
            return;
        }

        isUserValuePresentInDb = false;
        isDeviceIdPresentInDb = false;

        $scope.doLoginFunction(false);
    }

    $scope.checkAndDoLogin = function () {

        isUserValuePresentInDb = false;
        isDeviceIdPresentInDb = false;

        chessDb.transaction(function (transaction) {
            transaction.executeSql('Select * From LoginDetail Where LoginId=1', [],
                function (tx, result) {
                    var len = result.rows.length

                    if (len > 0) {

                        $scope.$apply(function () {
                            $scope.txtUserName = result.rows.item(0).UserName;
                            $scope.txtPassword = result.rows.item(0).Password;
                            $scope.mobileDeviceId = result.rows.item(0).MobileDeviceId;
                            $scope.fireBaseId = result.rows.item(0).FirebaseId;
                        });

                        if (result.rows.item(0).UserName != "" && result.rows.item(0).Password != "") {
                            isUserValuePresentInDb = true;
                            $scope.doLoginFunction(false);
                        }
                        else if (result.rows.item(0).MobileDeviceId != null && result.rows.item(0).MobileDeviceId != "") {
                            isDeviceIdPresentInDb = true;
                            $scope.doLoginFunction(true);
                        }
                    }
                    else if ($scope.mobileDeviceId != null && $scope.mobileDeviceId != "") {
                        isDeviceIdPresentInDb = false;
                        $scope.doLoginFunction(true);
                    }
                    else {
                        isUserValuePresentInDb = false;
                        isDeviceIdPresentInDb = false;

                        $scope.toggleSignupLogin(2, 1);
                    }
                },
                function (error) {
                    isUserValuePresentInDb = false;
                    isDeviceIdPresentInDb = false;
                    $scope.toggleSignupLogin(2, 1);
                });
        });
    }

    $scope.DoLoginProcess = function () {
        chessDb.transaction(function (transaction) {
            transaction.executeSql('CREATE TABLE IF NOT EXISTS LoginDetail (LoginId integer primary key, UserName text, Password text, MobileDeviceId text, ApiDeviceId text, FirebaseId text)', [],
                function (tx, result) {
                    $scope.checkAndDoLogin();
                },
                function (error) {
                    $scope.toggleSignupLogin(2, 1);
                });
        });
    }

    var GetMessageFromFCM = function () {
        try {
            $scope.pushObject.on('notification', function (data) {
                alert(data.message);
            });
        } catch (e) {
            alert(e);
        }
    }

    if (isAndroidApp && $scope.pushObject != null) {
        getFirebaseToken();
        GetMessageFromFCM();
    }
    else {
        $scope.toggleSignupLogin(2, 0);
    }

    $scope.doInsertIntoLocalDb = function (userName, password, deviceId, mobileDeviceId, fireBaseId) {

        if (!isAndroidApp)
            return;

        chessDb.transaction(function (transaction) {

            transaction.executeSql('Select * From LoginDetail Where LoginId=1', [],
                function (tx, result) {
                    var len = result.rows.length
                    if (len > 0) {

                        transaction.executeSql('Update LoginDetail Set UserName=?,Password=?,MobileDeviceId=?,ApiDeviceId=?,FirebaseId=? Where LoginId=1',
                            [userName, password, mobileDeviceId, deviceId, fireBaseId],
                            function (tx, results) {
                                //alert("S - doUpdateIntoLocalDb - 1");
                            },
                            function (error) {
                                //alert("F - doUpdateIntoLocalDb - 1");
                            });

                    }
                    else {

                        transaction.executeSql('Insert Into LoginDetail(UserName,Password,MobileDeviceId,ApiDeviceId,FirebaseId) Values (?,?,?,?,?)',
                            [userName, password, mobileDeviceId, deviceId, fireBaseId],
                            function (tx, results) {
                                //alert("S - doInsertIntoLocalDb - 1");
                            },
                            function (error) {
                                //alert("F - doInsertIntoLocalDb - 2");
                            });

                    }
                },
                function (error) {
                    $scope.toggleSignupLogin(2, 1);
                });
        });

    }

    $scope.doRegistration = function () {
        $scope.redAlert = "";
        $scope.greenAlert = "";

        if ($scope.txtUserName == null || $scope.txtUserName == "") {
            $scope.redAlert = "Please enter username.";
            return;
        }

        if ($scope.txtUserName.length < 8) {
            $scope.redAlert = "Username should be minimum eight characters.";
            return;
        }

        if ($scope.txtPassword == null || $scope.txtPassword == "") {
            $scope.redAlert = "Please enter password.";
            return;
        }

        if ($scope.txtPassword.length < 8) {
            $scope.redAlert = "Password should be minimum eight characters.";
            return;
        }

        if ($scope.txtPassword != $scope.txtConfirmPassword) {
            $scope.redAlert = "Password mismatch";
            return;
        }

        // Open;
        UIService.showLoader('main');
        var promise = commonService.doRegistration($scope.txtUserName, $scope.txtPassword, $scope.mobileDeviceId, $scope.fireBaseId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            // Close;

            if (data != null) {
                if (data.IsSuccess && data.OtherInfo != null) {
                    Session.updateSession(data.OtherInfo);
                    Session.setUserName($scope.txtUserName);

                    $scope.doInsertIntoLocalDb($scope.txtUserName, $scope.txtPassword, data.OtherInfo, $scope.mobileDeviceId, $scope.fireBaseId);
                    location.href = "#/mygamelist";
                }
                else {
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }
}]);

app.controller("MyGameListCtrl", ['$scope', '$uibModal', 'commonService', 'Session', 'UIService', function ($scope, $uibModal, commonService, Session, UIService) {
    $("body").removeClass("menu-on");

    var deviceId = Session.getSession();

    var containerHeight = window.innerHeight - 170;
    $scope.ContainerHeight = containerHeight + "px";

    if (deviceId == "") {
        //alert(deviceId);
        location.href = "#/login";
        return;
    }

    $scope.MyTurnBottomStyle = "";
    $scope.OpponentTurnBottomStyle = "";
    $scope.CompletedBottomStyle = "";
    $scope.RequestBottomStyle = "";
    $scope.OnGoingBottomStyle = "";
    $scope.TournamentBottomStyle = "";

    $scope.redAlert = "";
    $scope.greenAlert = "";
    $scope.TotalMatchCount = 0;

    $scope.showMyGameList = "block";

    $scope.gameViewSelected = { label: "All Matches", value: 0, selected: "selected" };
    $scope.gameViewSelected.value = Session.getFilterGameOption();

    $scope.gameViewOptions = [{ label: "All Matches", value: 0, selected: "selected" }, { label: "Friendly Matches", value: 1 }, { label: "Tournament Matches", value: 2 }];

    //$scope.DayPerMoveId = 1;

    $scope.GameList = [];
    //$scope.GameList = [{ BoardId: "Testing", WhiteUserName: "Rajkumar", BlackUserName: "Testing", Result: "*", Message: "Testing", ShowApproveApproveButton: true, ShowViewGameButton: false },
    //{ BoardId: "Testing", WhiteUserName: "Testing", BlackUserName: "Rajkumar", Result: "*", Message: "White To Move", ShowApproveApproveButton: false, ShowViewGameButton: true },
    //{ BoardId: "Testing", WhiteUserName: "Rajkumar", BlackUserName: "Testing", Result: "1-0", Message: "White Wins", ShowApproveApproveButton: false, ShowViewGameButton: true },
    //{ BoardId: "Testing", WhiteUserName: "Testing", BlackUserName: "Rajkumar", Result: "0-1", Message: "Black Wins", ShowApproveApproveButton: false, ShowViewGameButton: true }];

    //$scope.colorOptions = [{ label: "White", value: "1", selected: "selected" }, { label: "Black", value: "2" }];

    $scope.SetBorderStyle = function (gameOption) {
        $scope.MyTurnBottomStyle = "";
        $scope.OpponentTurnBottomStyle = "";
        $scope.CompletedBottomStyle = "";
        $scope.RequestBottomStyle = "";
        $scope.OnGoingBottomStyle = "";

        if (gameOption == 1) {
            $scope.MyTurnBottomStyle = "border-bottom:solid;border-color:green;";
        }
        else if (gameOption == 2) {
            $scope.OpponentTurnBottomStyle = "border-bottom:solid;border-color:orange;";
        }
        else if (gameOption == 3) {
            $scope.CompletedBottomStyle = "border-bottom:solid;border-color:red;";
        }
        else if (gameOption == 4) {
            $scope.RequestBottomStyle = "border-bottom:solid;border-color:orange;";
        }
        else if (gameOption == 5) {
            $scope.OnGoingBottomStyle = "border-bottom:solid;border-color:blue;";
        }
    }

    $scope.doShowPlayersToSelect = function () {
        var modalInstance = $uibModal.open({
            animation: true,
            backdrop: 'static',
            keyboard: false,
            templateUrl: 'modal/PlayerSuggestions.html',
            controller: 'playerSuggestionCtrl',
            size: 'lg',
            scope: $scope.$new()
        });

        modalInstance.result.then(function (result) {
        }, null);
    }

    $scope.loadMyGameList = function (gameOption) {
        Session.setViewOption(gameOption);
        $scope.SetBorderStyle(gameOption);
        var filterOption = Session.getFilterGameOption();

        $scope.redAlert = "";
        UIService.showLoader('main');
        $scope.GameList = [];

        var promise = commonService.getMyGameList(deviceId, gameOption, filterOption);

        promise.then(function (data) {
            UIService.hideLoader('main');
            if (data != null) {
                if (data.IsSuccess) {
                    $scope.GameList = data.MatchDetailList;
                    $scope.TotalMatchCount = $scope.GameList.length;

                    if (data.IsToShowSuggestGames)
                        $scope.doShowPlayersToSelect();//To Show Player Details to create match.
                }
                else {
                    $scope.redAlert = data.Message;
                    $scope.GameList = [];
                    $scope.TotalMatchCount = $scope.GameList.length;
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.FilterGameView = function () {
        var option = Session.getViewOption();
        Session.setFilterGameOption($scope.gameViewSelected.value);

        $scope.loadMyGameList(option);
    }

    $scope.GoToGame = function (game) {
        Session.setBoardId(game.BoardId);
        location.href = "#/board";
    }

    $scope.goToTournamentList = function () {
        location.href = "#/tournamentList";
    }

    $scope.togglePlayerAndGames = function (selectedOption) {
        if (selectedOption == 1) {
            $scope.PlayerList = [];
            $scope.loadShowPlayerList();

            $scope.showPlayerList = "block";
            $scope.showMyGameList = "none";
        }
        else if (selectedOption == 2) {
            $scope.GameList = [];

            var option = Session.getViewOption();
            $scope.loadMyGameList(option);

            $scope.showMyGameList = "block";
        }
    }

    $scope.approveOrRejectGameRequest = function (game, requestMode) {
        $scope.redAlert = "";

        var msg = ""; // "Do you want to approve this Game request?";
        var isApproved = false;
        var exeMode = "";

        if (requestMode == 1) {
            exeMode = "ApproveGame";
            isApproved = true;
            msg = "Do you want to approve this Game request?";
        }
        else if (requestMode == 2) {
            exeMode = "ApproveGame";
            isApproved = false;
            msg = "Do you want to reject this Game request?";
        }
        else if (requestMode == 3) {
            exeMode = "WITHDRAW";
            isApproved = false;
            msg = "Do you want to withdraw your Game request?";
        }

        var actionConfirm = confirm(msg);

        if (!actionConfirm) {
            return;
        }

        UIService.showLoader('main');
        var promise = commonService.approveOrRejectGameRequest(exeMode, game.BoardId, deviceId, isApproved);

        promise.then(function (data) {
            UIService.hideLoader('main');
            if (data != null) {
                // alert(data.IsSuccess);
                if (data.IsSuccess) {

                    if (requestMode == 1) {
                        alert("You have Approved the game request!");
                    }
                    else if (requestMode == 2) {
                        alert("You have Rejected the game request!");
                    }
                    else if (requestMode == 3) {
                        alert("You have Withdrawn the game request!");
                    }

                    $scope.loadMyGameList(4);
                }
                else {
                    game.Message = "Board Detail Not Present";
                }
            }
            else {
                // alert("Please check internet connectivity.");
                game.Message = "Please check internet connectivity.";
            }
        });
    }

    if (deviceId != "") {
        $scope.togglePlayerAndGames(2);
    }
}]);

app.controller("PlayerListCtrl", ['$scope', 'commonService', 'Session', 'UIService', function ($scope, commonService, Session, UIService) {
    $("body").removeClass("menu-on");

    var deviceId = Session.getSession();
    var containerHeight = window.innerHeight - 170;
    $scope.ContainerHeight = containerHeight + "px";

    if (deviceId == "") {
        //alert(deviceId);
        location.href = "#/login";
        return;
    }

    $scope.redAlert = "";
    $scope.greenAlert = "";
    $scope.showPlayerList = "block";
    $scope.searchName = "";

    $scope.DayPerMoveList = [{ "id": 2, "name": "2 days per move" }, { "id": 3, "name": "3 days per move" },
    { "id": 5, "name": "5 days per move" },
    { "id": 8, "name": "1 hour per move" },
    { "id": 9, "name": "30 minutes per move" },
    { "id": 10, "name": "1 minute per move (Rapid)" }
    ];

    //, { "id": 7, "name": "7 days per move" }

    $scope.BoardColor = [{ "id": true, "name": "White" }, { "id": false, "name": "Black" }];

    $scope.PlayerList = [];
    //$scope.PlayerList = [{ UserName: "Testing", WhiteBoard: true, Msg: "" }, { UserName: "Testing123", WhiteBoard: true, Msg: "" }];

    $scope.loadShowPlayerList = function () {
        $scope.redAlert = "";

        UIService.showLoader('main');
        var promise = commonService.getPlayerList(deviceId, $scope.searchName);

        promise.then(function (data) {
            UIService.hideLoader('main');
            if (data != null) {
                if (data.IsSuccess) {
                    $scope.PlayerList = data.UserIdNameList;
                    $scope.redAlert = data.Message;
                }
                else {
                    $scope.redAlert = "Please check internet connectivity.";
                    $scope.PlayerList = [];
                }
            }
            else {

                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.RequestGame = function (player) {
        $scope.redAlert = "";
        var currentUserId = Session.getSession();
        $scope.redAlert = "";
        $scope.greenAlert = "";
        player.Msg = "";

        if (player != null && currentUserId != "") {
            var whiteColor = player.WhiteBoard;

            //### Start: Automate this
            var daysPerMove = 0; // player.DaysPerMove;
            var hoursPerMove = 0;
            var minutesPerMove = 0;

            if (player.DaysPerMove < 8) {
                daysPerMove = player.DaysPerMove;
            }
            else if (player.DaysPerMove == 8) {
                hoursPerMove = 1;
            }
            else if (player.DaysPerMove == 9) {
                minutesPerMove = 30;
            }
            else if (player.DaysPerMove == 10) {
                minutesPerMove = 1;
            }
            //### End: Automate this

            var currentUserId = Session.getSession();

            var whiteId = "";
            var blackId = "";
            //var startPosition = Session.getStartPosition();
            //var result = "*";
            //var resultDesc = "Pending"; //Pending, Approved, In Progress, Completed

            if (whiteColor == true) {
                whiteId = currentUserId;
                blackId = player.UserId;
            }
            else {
                whiteId = player.UserId;
                blackId = currentUserId;
            }

            var requestInfo = {
                WhiteId: whiteId,
                BlackId: blackId,
                RequestedBy: currentUserId,
                DaysPerMove: daysPerMove,
                HoursPerMove: hoursPerMove,
                MinutesPerMove: minutesPerMove
            };

            //alert(requestInfo);
            //return;

            UIService.showLoader('main');
            var promise = commonService.sendGameRequest(requestInfo);

            promise.then(function (data) {
                UIService.hideLoader('main');
                if (data != null) {
                    if (data.IsSuccess) {
                        //$scope.greenAlert = "Request Sent!";

                        player.Msg = data.Message;
                    }
                    else {
                        player.Msg = data.Message;
                    }
                }
                else {
                    $scope.redAlert = "Please check internet connectivity.";
                }
            });
        }
    }

    $scope.togglePlayerAndGames = function (selectedOption) {
        if (selectedOption == 1) {
            $scope.PlayerList = [];
            $scope.loadShowPlayerList();

            $scope.showPlayerList = "block";
        }
        else if (selectedOption == 2) {
            location.href = "#/mygamelist";
        }
    }

    if (deviceId != "") {
        $scope.togglePlayerAndGames(1);
    }
}]);

app.controller("boardCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {
    var deviceId = Session.getSession();
    var boardId = Session.getBoardId();

    var isInServiceCall = false;
    var canDoBackGroundMove = false;

    $scope.boardDetail = null;

    $scope.HideMsgArea = true;

    if (deviceId == "" && releaseMode) {
        location.href = "#/login";
        return;
    }

    if (boardId == "" && releaseMode) {
        location.href = "#/mygamelist";
        return;
    }

    curUserId = deviceId;


    // Get Board Detail
    $scope.GetBoardDetail = function (boardId, deviceId) {
        $scope.redAlert = "";

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
            return;
        }

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getBoardDetail(boardId, deviceId);

        promise.then(function (data) {
            isInServiceCall = false;

            UIService.hideLoader('main');
            if (data != null) {
                // alert(data.IsSuccess);
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;

                    $scope.boardDetail = data.BoardDetail;
                    populateMatchDetail($scope.boardDetail);
                }
                else {
                    $scope.HideMsgArea = false;

                    $scope.redAlert = "Board Detail Not Present";
                }
            }
            else {
                $scope.HideMsgArea = false;
                // alert("Please check internet connectivity.");
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    var populateMatchDetail = function (bDetail) {

        if (releaseMode && bDetail.Result == "*" && (curUserId == bDetail.LastMovedBy || (curUserId != bDetail.WhiteId && curUserId != bDetail.BlackId))) {
            canDoBackGroundMove = true;
        }
        else {
            canDoBackGroundMove = false;
        }

        PopulateBoardDetail(bDetail, $scope);
    }

    $scope.UpdateMoveDetail = function (moveDetail) {

        var moveConfirm = confirm("Are you sure want to make this Move?");

        if (!moveConfirm) {
            populateMatchDetail($scope.boardDetail);
            return;
        }

        $scope.redAlert = "";

        moveDetail.BoardId = boardId;
        moveDetail.LastMovedBy = deviceId;

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.submitBoardDetail(moveDetail);

        promise.then(function (data) {
            UIService.hideLoader('main');

            isInServiceCall = false;
            canDoBackGroundMove = true;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;
                    $scope.GetBoardDetail(boardId, deviceId);

                    // document.getElementById("divLastMovedOn").innerHTML = data.DateTimeString;
                }
                else {
                    $scope.HideMsgArea = false;
                    $scope.redAlert = "Move Not Updated";
                }
            }
            else {
                $scope.HideMsgArea = false;
                // alert("Please check internet connectivity.");
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.ClaimWin = function () {
        $scope.redAlert = "";

        if (deviceId == "") {
            location.href = "#/login";
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
        }

        var canClaimWin = confirm("Do you want to Claim Win?");

        if (!canClaimWin)
            return;

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.claimWinExecute(boardId, deviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;
                    $scope.GetBoardDetail(boardId, deviceId);
                }
                else {
                    $scope.HideMsgArea = false;
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.HideMsgArea = false;
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.Resign = function () {
        $scope.redAlert = "";

        if (deviceId == "") {
            location.href = "#/login";
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
        }

        var isResign = confirm("Give Tough Fight before resign, still, do you want to Resign?");

        if (!isResign)
            return;

        //alert("resign");

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.resignMatchExecute(boardId, deviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;
                    $scope.GetBoardDetail(boardId, deviceId);
                }
                else {
                    $scope.HideMsgArea = false;
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.HideMsgArea = false;
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.Draw = function () {
        $scope.redAlert = "";

        if (deviceId == "") {
            location.href = "#/login";
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
        }

        var isConfirm = confirm("Do you want to send Draw Request to Opponent?");

        if (!isConfirm)
            return;

        //alert("resign");

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.drawMatchExecute(boardId, deviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;
                    $scope.GetBoardDetail(boardId, deviceId);
                }
                else {
                    $scope.HideMsgArea = false;
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.HideMsgArea = false;
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.ApproveOrRejectDraw = function () {
        $scope.redAlert = "";

        if (deviceId == "") {
            location.href = "#/login";
        }

        if (boardId == "") {
            location.href = "#/mygamelist";
        }

        var isConfirm = confirm("Do you want to take action on this Draw Request?");

        if (!isConfirm)
            return;

        isConfirm = confirm("Click \"Ok\" to Approve (or) \"Cancel\" to Reject the Draw Request");

        //alert("resign");

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.approveRejectDrawRequest(boardId, deviceId, isConfirm);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.HideMsgArea = true;
                    $scope.GetBoardDetail(boardId, deviceId);
                }
                else {
                    $scope.HideMsgArea = false;
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.HideMsgArea = false;
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.Refresh = function () {
        $scope.GetBoardDetail(boardId, deviceId);
    }

    $scope.GetBoardDetail(boardId, deviceId);

    $scope.AutoRefresh = function () {
        if (!isInServiceCall && canDoBackGroundMove) {
            $scope.GetBoardDetail(boardId, deviceId);
        }
    }

    var autoRefreshAction = $interval($scope.AutoRefresh, boardRefreshInMs);

    $scope.$on("$destroy", function () {
        if (autoRefreshAction != null) {
            $interval.cancel(autoRefreshAction);
        }
    });

    $scope.goToChat = function () {
        location.href = "#/chat";
    }
}]);

app.controller("PlayerStatisticsCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {
    $("body").removeClass("menu-on");

    var deviceId = Session.getSession();
    $scope.showNoConnection = "none";
    $scope.showPlayerStatistics = "none";

    $scope.GameWin = 0;
    $scope.GameLost = 0;
    $scope.GameDrawn = 0;
    $scope.GameInProgress = 0;
    $scope.SentRequestPendingCount = 0;

    var containerHeight = window.innerHeight - 320;
    $scope.ContainerHeight = containerHeight + "px";

    $scope.PlayerGamesStatList = [];

    var isInServiceCall = false;

    if (deviceId == "") {
        location.href = "#/login";
        return;
    }

    $scope.GetPlayerStatistics = function (curDeviceId) {
        $scope.redAlert = "";
        $scope.greenAlert = "";
        $scope.PlayerGamesStatList = [];

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getPlayerStatistics(curDeviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.PlayerStatistics != null) {
                    $scope.showNoConnection = "none";
                    $scope.showPlayerStatistics = "block";

                    var pageData = data.PlayerStatistics;

                    $scope.GameWin = pageData.GameWin;
                    $scope.GameLost = pageData.GameLost;
                    $scope.GameDrawn = pageData.GameDrawn;
                    $scope.GameInProgress = pageData.GameInProgress;
                    $scope.SentRequestPendingCount = pageData.SentRequestPendingCount;

                    $scope.PlayerGamesStatList = pageData.PlayerStatisticsList;
                }
                else {

                    $scope.showNoConnection = "block";
                    $scope.showPlayerStatistics = "none";

                    $scope.redAlert = "No data found.";
                }
            }
            else {
                $scope.showNoConnection = "block";
                $scope.showPlayerStatistics = "none";

                // alert("Please check internet connectivity.");
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.GetPlayerStatistics(deviceId);
}]);

app.controller("NotificationCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {
    $("body").removeClass("menu-on");

    var deviceId = Session.getSession();
    var containerHeight = window.innerHeight - 170;
    $scope.ContainerHeight = containerHeight + "px";

    $scope.NotificationList = [];

    var isInServiceCall = false;

    if (deviceId == "") {
        location.href = "#/login";
        return;
    }

    $scope.onNotificationTravel = function (notification) {
        if (notification != null && notification.BoardId != "") {
            Session.setBoardId(notification.BoardId);
            location.href = "#/board";
        }
    }

    $scope.getPlayerNofitication = function () {

        var curDeviceId = Session.getSession();

        $scope.redAlert = "";
        $scope.greenAlert = "";
        $scope.NotificationList = [];

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getPlayerNofitication(curDeviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.NotificationDetailList != null) {
                    $scope.NotificationList = data.NotificationDetailList;
                }
                else {
                    $scope.redAlert = "No notification found.";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.getPlayerNofitication();
}]);

app.controller("tournamentListCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {

    var containerHeight = window.innerHeight - 150;
    $scope.ContainerHeight = containerHeight + "px";

    var deviceId = Session.getSession();
    $scope.TournamentDetailList = [];
    $scope.redAlert = "";
    $scope.greenAlert = "";

    var isInServiceCall = false;

    if (deviceId == "") {
        location.href = "#/login";
        return;
    }

    $scope.goToGameList = function (tournament) {
        var curDeviceId = Session.getSession();

        if (curDeviceId == "") {
            location.href = "#/login";
            return;
        }

        location.href = "#/mygamelist";
    }

    $scope.ViewTournament = function (tournament) {
        if (tournament != null && tournament.TournamentId != "") {
            Session.setTournamentId(tournament.TournamentId);
            Session.setTournamentRound(1);
            Session.setTournamentRoundStatus(0);

            location.href = "#/tournamentDetail";
        }
    }

    $scope.EditTournament = function (tournament) {
        if (tournament != null && tournament.TournamentId != "") {
            Session.setTournamentId(tournament.TournamentId);
            location.href = "#/addUpdateTournamentDetail";
        }
    }

    $scope.JoinTournament = function (tournament) {
        var curDeviceId = Session.getSession();

        if (curDeviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournament != null && tournament.TournamentId != "") {
            $scope.redAlert = "";

            isInServiceCall = true;
            UIService.showLoader('main');
            var promise = commonService.joinTournament(curDeviceId, tournament.TournamentId);

            promise.then(function (data) {
                UIService.hideLoader('main');
                isInServiceCall = false;

                if (data != null) {
                    tournament.Message = data.Message;

                    if (data.ErrorCode == "APPROVED") {
                        //$scope.$apply(function () {

                        tournament.CanSendRequest = false;
                        tournament.CanViewTournament = true;
                        //});
                    }
                    else if (data.ErrorCode == "PENDING") {
                        //$scope.$apply(function () {

                        tournament.CanSendRequest = false;
                        tournament.CanViewTournament = false;

                        // });
                    }
                }
                else {
                    $scope.redAlert = "Please check internet connectivity.";
                }
            });
        }
    }

    $scope.getTournamentList = function () {

        var curDeviceId = Session.getSession();

        $scope.redAlert = "";
        $scope.greenAlert = "";
        $scope.NotificationList = [];

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getTournamentList(curDeviceId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.TournamentDetailList != null) {
                    $scope.TournamentDetailList = data.TournamentDetailList;
                }
                else {
                    $scope.redAlert = "No tournament found.";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.getTournamentList();
}]);

app.controller("tournamentDetailCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {
    var deviceId = Session.getSession();
    var tournamentId = Session.getTournamentId();
    var mobileDeviceId = "";

    if (deviceId == "") {
        location.href = "#/login";
        return;
    }

    if (tournamentId == "") {
        location.href = "#/tournamentList";
        return;
    }

    $scope.tournamentAdminSection = "none";

    $scope.TournamentDetail = {};
    $scope.PlayerList = [];
    $scope.FixtureDetailList = [];
    $scope.AutoFixtureDetailList = [];

    $scope.playerListRedAlert = "";
    $scope.adminSectionRedAlert = "";
    $scope.fixtureResultRedAlert = "";
    $scope.timingSectionRedAlert = "";
    $scope.autoFixtureResultRedAlert = "";

    $scope.AdminSection = { "Round": 1, "WhiteId": null, "BlackId": null, "Comment": "", "Msg": "" };
    $scope.FixtureListSection = { "Round": 1 };
    $scope.AutoFixtureListSection = { "Round": 0 };

    $scope.FixtureResultList = [
        { "id": 0, "name": "All" },
        { "id": 1, "name": "In Progress" },
        { "id": 2, "name": "Completed" }
    ];
    $scope.FixtureResult = { "Result": 0 };

    $scope.RoundList = [
        { "id": 1, "name": "Round 1" },
        { "id": 2, "name": "Round 2" },
        { "id": 3, "name": "Round 3" },
        { "id": 4, "name": "Round 4" },
        { "id": 5, "name": "Round 5" },
        { "id": 6, "name": "Round 6" },
        { "id": 7, "name": "Round 7" },
        { "id": 8, "name": "Round 8" },
        { "id": 9, "name": "Round 9" },
        { "id": 10, "name": "Round 10" }
    ];

    $scope.TournamentStatuses = [
        { "id": 1, "name": "Yet To Start" },
        { "id": 2, "name": "Started" },
        { "id": 3, "name": "Completed" }
    ];

    // Start: Setting Default Values
    $scope.FixtureListSection.Round = Session.getTournamentRound();
    $scope.FixtureResult.Result = Session.getTournamentRoundStatus();
    // End: Setting Default Values

    var isInServiceCall = false;

    $scope.goToGameList = function () {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        location.href = "#/mygamelist";
    }

    $scope.goToTournamentList = function () {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        location.href = "#/tournamentList";
    }

    $scope.getTournamentDetail = function () {

        var curDeviceId = Session.getSession();
        var curTournamentId = Session.getTournamentId();

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getTournamentDetail(curDeviceId, curTournamentId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.TournamentViewDetail != null) {
                    $scope.TournamentDetail = data.TournamentViewDetail.TournamentDetail;
                    $scope.PlayerList = data.TournamentViewDetail.TournamentPlayerList;

                    if ($scope.TournamentDetail != null && $scope.TournamentDetail.IsTournamentAdmin)
                        $scope.tournamentAdminSection = "block";
                    else
                        $scope.tournamentAdminSection = "none";
                }
                else {
                    $scope.redAlert = "No tournament found.";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.getFixtureList = function () {
        Session.setTournamentRound($scope.FixtureListSection.Round);
        Session.setTournamentRoundStatus($scope.FixtureResult.Result);

        deviceId = Session.getSession();
        tournamentId = Session.getTournamentId();
        mobileDeviceId = Session.getMobileDeviceId();

        $scope.fixtureResultRedAlert = "";

        //alert($scope.FixtureResult.Result);

        var requestInfo = {
            TournamentId: tournamentId,
            DeviceId: deviceId,
            MobileDeviceId: mobileDeviceId,
            Round: $scope.FixtureListSection.Round,
            Result: $scope.FixtureResult.Result
        };

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getFixtureList(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.FixtureDetailList != null) {
                    $scope.FixtureDetailList = data.FixtureDetailList;
                }
                else {
                    $scope.FixtureDetailList = [];
                    $scope.fixtureResultRedAlert = data.Message;
                }
            }
            else {
                $scope.FixtureDetailList = [];
                $scope.fixtureResultRedAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.refreshTournamentDetail = function () {
        $scope.getTournamentDetail();
        $scope.getFixtureList();
    };

    $scope.refreshTournamentDetail();

    $scope.ApproveOrRejectRequest = function (player, isApproved) {
        if (player != null && player.PlayerId != "" && player.TournamentId != "") {
            mobileDeviceId = Session.getMobileDeviceId();
            $scope.playerListRedAlert = ""

            isInServiceCall = true;
            UIService.showLoader('main');
            var promise = commonService.approveOrRejectTournament(mobileDeviceId, player.PlayerId, player.TournamentId, isApproved);

            promise.then(function (data) {
                UIService.hideLoader('main');
                isInServiceCall = false;

                if (data != null) {
                    if (data.IsSuccess) {
                        $scope.playerListRedAlert = data.Message;

                        $scope.getTournamentDetail();
                    }
                    else {
                        $scope.playerListRedAlert = data.Message;
                    }
                }
                else {
                    $scope.playerListRedAlert = "Please check internet connectivity.";
                }
            });
        }
    }

    $scope.GenerateFixture = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        if ($scope.AdminSection.Round == null || $scope.AdminSection.Round == undefined) {

            $scope.adminSectionRedAlert = "Please select Round.";
            return;
        }
        else if ($scope.AdminSection.WhiteId == null || $scope.AdminSection.WhiteId == undefined || $scope.AdminSection.WhiteId == "") {
            $scope.adminSectionRedAlert = "Please select White.";
            return;
        }
        else if ($scope.AdminSection.BlackId == null || $scope.AdminSection.BlackId == undefined || $scope.AdminSection.BlackId == "") {
            $scope.adminSectionRedAlert = "Please select Black.";
            return;
        }
        else if ($scope.AdminSection.WhiteId == $scope.AdminSection.BlackId) {
            $scope.adminSectionRedAlert = "White & Black can't be same.";
            return;
        }

        var requestInfo = {
            WhiteId: $scope.AdminSection.WhiteId,
            BlackId: $scope.AdminSection.BlackId,
            TournamentId: tournamentId,
            CreatedBy: deviceId,
            Round: $scope.AdminSection.Round,
            MobileDeviceId: mobileDeviceId,
            Comment: $scope.AdminSection.Comment
        };

        $scope.adminSectionRedAlert = ""

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.createFixtureForTournament(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.adminSectionRedAlert = data.Message;
                    $scope.getFixtureList();
                }
                else {
                    $scope.adminSectionRedAlert = data.Message;
                }
            }
            else {
                $scope.adminSectionRedAlert = "Please check internet connectivity.";
            }
        });

        // alert($scope.AdminSection.Round + "_" + $scope.AdminSection.WhiteId + "_" + $scope.AdminSection.BlackId);
    }

    $scope.goToBoard = function (fixture) {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (fixture == null || fixture.BoardId == null || fixture.BoardId == "") {
            alert("Fixture is not having details.");
            return;
        }

        Session.setBoardId(fixture.BoardId);
        location.href = "#/board";
    };

    $scope.createGame = function (fixture) {

        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        if (fixture == null) {
            alert("Fixture is not having details.");
            return;
        }

        fixture.DeviceId = deviceId;
        fixture.MobileDeviceId = mobileDeviceId;

        $scope.fixtureResultRedAlert = ""

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.createBoardForFixture(fixture);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.fixtureResultRedAlert = data.Message;
                    $scope.getFixtureList();
                }
                else {
                    $scope.fixtureResultRedAlert = data.Message;
                }
            }
            else {
                $scope.fixtureResultRedAlert = "Please check internet connectivity.";
            }
        });
    };

    $scope.ChangeTournamentStatus = function () {

        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        var requestInfo = {
            TournamentId: tournamentId,
            DeviceId: deviceId,
            MobileDeviceId: mobileDeviceId,
            StatusId: $scope.TournamentDetail.Status
        };

        $scope.adminSectionRedAlert = ""

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.changeTournamentStatus(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.adminSectionRedAlert = data.Message;
                    $scope.getTournamentDetail();
                }
                else {
                    $scope.adminSectionRedAlert = data.Message;
                }
            }
            else {
                $scope.adminSectionRedAlert = "Please check internet connectivity.";
            }
        });
    };

    $scope.updateTournamentDetail = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        var requestInfo = {
            TournamentId: tournamentId,
            UserId: deviceId,
            MobileDeviceId: mobileDeviceId,
            DaysPerMove: $scope.TournamentDetail.DaysPerMove,
            HoursPerMove: $scope.TournamentDetail.HoursPerMove,
            MinutesPerMove: $scope.TournamentDetail.MinutesPerMove
        };

        $scope.timingSectionRedAlert = "";

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.updateTournamentDetail(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.timingSectionRedAlert = data.Message;
                    $scope.refreshTournamentDetail();
                }
                else {
                    $scope.timingSectionRedAlert = data.Message;
                }
            }
            else {
                $scope.timingSectionRedAlert = "Please check internet connectivity.";
            }
        });

    };

    $scope.generateAutoFixture = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        var requestInfo = {
            TournamentId: tournamentId,
            UserId: deviceId,
            MobileDeviceId: mobileDeviceId,
            Round: $scope.AutoFixtureListSection.Round
        };

        $scope.autoFixtureResultRedAlert = "";

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.generateAutoFixture(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.autoFixtureResultRedAlert = data.Message;
                    $scope.AutoFixtureDetailList = data.AutoFixtureDetailList;
                }
                else {
                    $scope.autoFixtureResultRedAlert = data.Message;
                }
            }
            else {
                $scope.autoFixtureResultRedAlert = "Please check internet connectivity.";
            }
        });

    };

    $scope.createAutoFixture = function (fixture) {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }


        var requestInfo = {
            WhiteId: fixture.WhiteId,
            BlackId: fixture.BlackId,
            TournamentId: tournamentId,
            CreatedBy: deviceId,
            Round: fixture.Round,
            MobileDeviceId: mobileDeviceId
        };

        $scope.autoFixtureResultRedAlert = ""

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.createFixtureForTournament(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.autoFixtureResultRedAlert = data.Message;
                    $scope.getFixtureList();
                }
                else {
                    $scope.autoFixtureResultRedAlert = data.Message;
                }
            }
            else {
                $scope.autoFixtureResultRedAlert = "Please check internet connectivity.";
            }
        });

    };

}]);

app.controller("addUpdateTournamentDetailCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {

    var deviceId = Session.getSession();
    var tournamentId = Session.getTournamentId();
    var mobileDeviceId = "";

    if (deviceId == "") {
        location.href = "#/login";
        return;
    }

    if (tournamentId == "") {
        location.href = "#/tournamentList";
        return;
    }

    $scope.tournamentAdminSection = "none";
    $scope.timingSectionRedAlert = "";

    $scope.TournamentDetail = {};

    var isInServiceCall = false;

    $scope.goToGameList = function () {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        location.href = "#/mygamelist";
    }

    $scope.goToTournamentList = function () {
        deviceId = Session.getSession();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        location.href = "#/tournamentList";
    }

    $scope.getTournamentDetail = function () {

        deviceId = Session.getSession();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.manageTournamentDetail(deviceId, tournamentId);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.TournamentViewDetail != null) {
                    $scope.TournamentDetail = data.TournamentViewDetail.TournamentDetail;

                    if ($scope.TournamentDetail != null && $scope.TournamentDetail.IsTournamentAdmin)
                        $scope.tournamentAdminSection = "block";
                    else
                        $scope.tournamentAdminSection = "none";
                }
                else {
                    $scope.redAlert = "No tournament found.";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });
    }

    $scope.refreshTournamentDetail = function () {
        $scope.getTournamentDetail();
    };

    $scope.refreshTournamentDetail();

    $scope.updateTournamentDetail = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();
        tournamentId = Session.getTournamentId();

        if (deviceId == "") {
            location.href = "#/login";
            return;
        }

        if (tournamentId == "") {
            location.href = "#/tournamentList";
            return;
        }

        var requestInfo = {
            TournamentId: tournamentId,
            UserId: deviceId,
            MobileDeviceId: mobileDeviceId,
            DaysPerMove: $scope.TournamentDetail.DaysPerMove,
            HoursPerMove: $scope.TournamentDetail.HoursPerMove,
            MinutesPerMove: $scope.TournamentDetail.MinutesPerMove
        };

        $scope.timingSectionRedAlert = "";

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.updateTournamentDetail(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.timingSectionRedAlert = data.Message;
                    $scope.refreshTournamentDetail();
                }
                else {
                    $scope.timingSectionRedAlert = data.Message;
                }
            }
            else {
                $scope.timingSectionRedAlert = "Please check internet connectivity.";
            }
        });

    };

}]);

app.controller("commentCtrl", ['$scope', 'commonService', 'Session', 'UIService', '$interval', function ($scope, commonService, Session, UIService, $interval) {
    $("body").removeClass("menu-on");

    var deviceId = Session.getSession();
    var mobileDeviceId = Session.getMobileDeviceId();

    $scope.CommentDetail = { "CommentTypeId": "", "Subject": "", "Comment": "" };
    $scope.CommentTypeList = [];

    $scope.redAlert = "";

    if (deviceId == "" || mobileDeviceId == "") {
        location.href = "#/login";
        return;
    }

    var isInServiceCall = false;

    $scope.goToGameList = function () {
        location.href = "#/mygamelist";
    }

    $scope.getCommentTypeList = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        var requestInfo = {
            UserId: deviceId,
            MobileDeviceId: mobileDeviceId
        };

        $scope.CommentTypeList = [];
        $scope.CommentDetail.CommentTypeId = "";
        $scope.redAlert = "";

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.getCommentType(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess && data.CommentTypeList != null) {
                    $scope.CommentTypeList = data.CommentTypeList;
                }
                else {
                    $scope.CommentTypeList = [];
                    $scope.redAlert = "No comment type present.";
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });

    };

    $scope.getCommentTypeList();

    $scope.submitCommentDetail = function () {
        deviceId = Session.getSession();
        mobileDeviceId = Session.getMobileDeviceId();

        if (deviceId == "" || mobileDeviceId == "") {
            location.href = "#/login";
            return;
        }

        if ($scope.CommentDetail.CommentTypeId == "") {
            $scope.redAlert = "Please select comment type";
            return;
        }
        else if ($scope.CommentDetail.Subject == "") {
            $scope.redAlert = "Please enter subject";
            return;
        }
        else if ($scope.CommentDetail.Comment == "") {
            $scope.redAlert = "Please enter comment";
            return;
        }

        var requestInfo = {
            UserId: deviceId,
            MobileDeviceId: mobileDeviceId,
            CommentTypeId: $scope.CommentDetail.CommentTypeId,
            Subject: $scope.CommentDetail.Subject,
            Description: $scope.CommentDetail.Comment
        };

        $scope.redAlert = "";

        isInServiceCall = true;
        UIService.showLoader('main');
        var promise = commonService.submitUserComment(requestInfo);

        promise.then(function (data) {
            UIService.hideLoader('main');
            isInServiceCall = false;

            if (data != null) {
                if (data.IsSuccess) {
                    $scope.redAlert = data.Message;

                    $scope.CommentDetail.CommentTypeId = "";
                    $scope.CommentDetail.Subject = "";
                    $scope.CommentDetail.Comment = "";
                }
                else {
                    $scope.redAlert = data.Message;
                }
            }
            else {
                $scope.redAlert = "Please check internet connectivity.";
            }
        });

    };
}]);