"use strict"
var app = angular.module("bApp");


/* Filters */
app
.filter('bDate', function($filter) {    
    var angularDateFilter = $filter('date');
    return function(theDate) {
		if(!angular.isDate(theDate)){
			theDate = new Date(theDate);
		}
		return angularDateFilter(theDate, 'dd MMM yyyy');
    }
})
.filter('htmlToPlaintext', function() {
	return function(text) {
		return  text ? String(text).replace(/<[^>]+>/gm, '') : '';
	};
})
.filter('cut', function () {
	return function (value, wordwise, max, tail) {
		if (!value) return '';

		max = parseInt(max, 10);
		if (!max) return value;
		if (value.length <= max) return value;

		value = value.substr(0, max);
		if (wordwise) {
			var lastspace = value.lastIndexOf(' ');
			if (lastspace != -1) {
			  //Also remove . and , so its gives a cleaner result.
			  if (value.charAt(lastspace-1) == '.' || value.charAt(lastspace-1) == ',') {
				lastspace = lastspace - 1;
			  }
			  value = value.substr(0, lastspace);
			}
		}

		return value + (tail || ' …');
	};
});