"use strict"

var app = angular.module("bApp", ['ngRoute', 'jQueryScrollbar', 'ui.bootstrap']);

app.config(['$routeProvider', '$locationProvider', function ($routeProvider, $locationProvider) {
    //$locationProvider.html5Mode({
    //    enabled: true,
    //    requireBase: false
    //});

    $routeProvider
    .when("/", {
        templateUrl: "LoadingPage.html",
        controller: 'LoadingPageCtrl',
        activetab: "LoadingPage"
    })
	.when("/login", {
	    templateUrl: "player/Login.html",
	    controller: 'LoginCtrl',
	    activetab: "Login"
	})
    .when("/mygamelist", {
        templateUrl: "player/MyGameList.html",
        controller: 'MyGameListCtrl',
        activetab: "MyGameList"
    })
    .when("/playerlist", {
        templateUrl: "player/PlayerList.html",
        controller: 'PlayerListCtrl',
        activetab: "PlayerList"
    })
    .when("/playerstatistics", {
        templateUrl: "player/PlayerStatistics.html",
        controller: 'PlayerStatisticsCtrl',
        activetab: "PlayerStatistics"
    })
    .when("/notificationList", {
        templateUrl: "player/Notification.html",
        controller: 'NotificationCtrl',
        activetab: "NotificationList"
    })
	.when('/board', {
	    templateUrl: 'board/board.html',
	    controller: 'boardCtrl',
	    activetab: "board"
	})
    .when('/tournamentList', {
        templateUrl: 'tournament/TournamentList.html',
        controller: 'tournamentListCtrl',
        activetab: "tournamentList"
    })
    .when('/tournamentDetail', {
        templateUrl: 'tournament/TournamentDetail.html',
        controller: 'tournamentDetailCtrl',
        activetab: "tournamentDetail"
    })
    .when('/addUpdateTournamentDetail', {
        templateUrl: 'tournament/AddUpdateTournamentView.html',
        controller: 'addUpdateTournamentDetailCtrl',
        activetab: "addUpdateTournamentDetail"
    })
    .when('/chat', {
        templateUrl: 'chat/Chat.html',
        controller: 'chatCtrl',
        activetab: "chat"
    })
    .when('/confirm', {
        templateUrl: 'player/NextConfirmation.html',
        controller: 'confirmCtrl',
        activetab: "confirm"
    })
    .when('/comment', {
        templateUrl: 'player/Comment.html',
        controller: 'commentCtrl',
        activetab: "comment"
    })
    .when('/privacyAgree', {
        templateUrl: 'privacy/Privacy.html',
        controller: 'privacyAgreeCtrl',
        activetab: "privacyAgree"
    })
	.otherwise({
	    redirectTo: "/"
	});

}]
);




















/* Dummy Model */
var news_List = [
	{ "title": "The Surprising Reasons People", "url": "/files/news/xyz.pdf", "date": "01/12/2016" },
	{ "title": "World-Renowned Soccer Star Tackles a New Challenge", "url": "/files/news/xyz.pdf", "date": "01/12/2016" },
	{ "title": "How a World Free from Viral Hepatitis is Possible", "url": "/files/news/xyz.pdf", "date": "01/12/2016" },
	{ "title": "The Surprising Reasons People", "url": "/files/news/xyz.pdf", "date": "01/12/2016" }
];

var blog_List = [
	{
	    "blogID": "111",
	    "category": 1,
	    "likes": 45,
	    "responses": 33,
	    "title": "People. Passion. Possibilities.",
	    "author": "John Doe",
	    "imageURL": "D:/Jerry/WORKS/Abbvie/template/v2.2/images/blog/image1.jpg",
	    "date": "01/12/2016",
	    "content": "<p>At AbbVie, we have the expertise of a proven pharmaceutical leader and the focus and passion of an entrepreneur and innovator. The result is something rare in health care today – a global biopharmaceutical company that has the ability to discover and advance innovative therapies and meet the health needs of people and societies around the globe.</p><p>When it comes to innovating, AbbVie starts with the patient. We draw on our deep expertise in some of the most difficult-to-treat diseases and on our understanding of the patient journey to identify opportunities to create better outcomes at every stage. This patient-centered approach to discovery and development ensures we remain focused on our goal of improving lives.</p><p>People today live longer, healthier lives, but along with a longer life expectancy comes a higher prevalence of chronic disease. We take a broad perspective on improving healthcare and are committed to new thinking and approaches; we strive to find new solutions that will enable healthcare systems to bring medical innovation to more patients cost effectively.</p>"
	},
	{
	    "blogID": "112",
	    "category": 1,
	    "likes": 15,
	    "responses": 25,
	    "title": "The Surprising Reasons People",
	    "author": "John Doe",
	    "imageURL": "D:/Jerry/WORKS/Abbvie/template/v2.2/images/blog/image1.jpg",
	    "date": "01/12/2016",
	    "content": "<p>At AbbVie, we have the expertise of a proven pharmaceutical leader and the focus and passion of an entrepreneur and innovator. The result is something rare in health care today – a global biopharmaceutical company that has the ability to discover and advance innovative therapies and meet the health needs of people and societies around the globe.</p><p>When it comes to innovating, AbbVie starts with the patient. We draw on our deep expertise in some of the most difficult-to-treat diseases and on our understanding of the patient journey to identify opportunities to create better outcomes at every stage. This patient-centered approach to discovery and development ensures we remain focused on our goal of improving lives.</p><p>People today live longer, healthier lives, but along with a longer life expectancy comes a higher prevalence of chronic disease. We take a broad perspective on improving healthcare and are committed to new thinking and approaches; we strive to find new solutions that will enable healthcare systems to bring medical innovation to more patients cost effectively.</p>"
	},
	{
	    "blogID": "113",
	    "category": 2,
	    "likes": 20,
	    "responses": 12,
	    "title": "World-Renowned Soccer Star Tackles a New Challenge",
	    "author": "John Doe", "imageURL": "D:/Jerry/WORKS/Abbvie/template/v2.2/images/blog/image1.jpg",
	    "date": "01/12/2016",
	    "content": "<p>At AbbVie, we have the expertise of a proven pharmaceutical leader and the focus and passion of an entrepreneur and innovator. The result is something rare in health care today – a global biopharmaceutical company that has the ability to discover and advance innovative therapies and meet the health needs of people and societies around the globe.</p><p>When it comes to innovating, AbbVie starts with the patient. We draw on our deep expertise in some of the most difficult-to-treat diseases and on our understanding of the patient journey to identify opportunities to create better outcomes at every stage. This patient-centered approach to discovery and development ensures we remain focused on our goal of improving lives.</p><p>People today live longer, healthier lives, but along with a longer life expectancy comes a higher prevalence of chronic disease. We take a broad perspective on improving healthcare and are committed to new thinking and approaches; we strive to find new solutions that will enable healthcare systems to bring medical innovation to more patients cost effectively.</p>"
	},
	{
	    "blogID": "114",
	    "category": 2,
	    "likes": 100,
	    "responses": 35,
	    "title": "How a World Free from Viral Hepatitis is Possible",
	    "author": "John Doe",
	    "imageURL": "D:/Jerry/WORKS/Abbvie/template/v2.2/images/blog/image1.jpg",
	    "date": "01/12/2016",
	    "content": "<p>At AbbVie, we have the expertise of a proven pharmaceutical leader and the focus and passion of an entrepreneur and innovator. The result is something rare in health care today – a global biopharmaceutical company that has the ability to discover and advance innovative therapies and meet the health needs of people and societies around the globe.</p><p>When it comes to innovating, AbbVie starts with the patient. We draw on our deep expertise in some of the most difficult-to-treat diseases and on our understanding of the patient journey to identify opportunities to create better outcomes at every stage. This patient-centered approach to discovery and development ensures we remain focused on our goal of improving lives.</p><p>People today live longer, healthier lives, but along with a longer life expectancy comes a higher prevalence of chronic disease. We take a broad perspective on improving healthcare and are committed to new thinking and approaches; we strive to find new solutions that will enable healthcare systems to bring medical innovation to more patients cost effectively.</p>"
	},
	{
	    "blogID": "115",
	    "category": 3,
	    "likes": 10,
	    "responses": 3,
	    "title": "How a World Free from Viral Hepatitis is Possible. How a World Free from Viral Hepatitis is Possible",
	    "author": "John Doe",
	    "imageURL": "D:/Jerry/WORKS/Abbvie/template/v2.2/images/blog/image1.jpg",
	    "date": "01/12/2016",
	    "content": "<p>At AbbVie, we have the expertise of a proven pharmaceutical leader and the focus and passion of an entrepreneur and innovator. The result is something rare in health care today – a global biopharmaceutical company that has the ability to discover and advance innovative therapies and meet the health needs of people and societies around the globe.</p><p>When it comes to innovating, AbbVie starts with the patient. We draw on our deep expertise in some of the most difficult-to-treat diseases and on our understanding of the patient journey to identify opportunities to create better outcomes at every stage. This patient-centered approach to discovery and development ensures we remain focused on our goal of improving lives.</p><p>People today live longer, healthier lives, but along with a longer life expectancy comes a higher prevalence of chronic disease. We take a broad perspective on improving healthcare and are committed to new thinking and approaches; we strive to find new solutions that will enable healthcare systems to bring medical innovation to more patients cost effectively.</p>"
	}
];




