"use strict"
var app = angular.module("bApp");
var localRef = "localhost";
var tokenInfo = "77E92512-2762-4D09-BE8A-06DE5E285C96";

var currentMode = { "info": { "serviceUrl": "http://www.developerin.net/capi/ccs", "isAndroidApp": true, "releaseMode": true, "allowServiceCall": true, "appVersion": "2.6" } };
//var currentMode = { "info": { "serviceUrl": "http://localhost:8066/ChessConnectService.svc/makerequest", "isAndroidApp": false, "releaseMode": false, "allowServiceCall": true, "appVersion": "2.6" } };

var serviceUrl = currentMode.info.serviceUrl;
var isAndroidApp = currentMode.info.isAndroidApp;
var releaseMode = currentMode.info.releaseMode;
var allowServiceCall = currentMode.info.allowServiceCall;
var curAppVersion = currentMode.info.appVersion;

//alert(isAndroidApp);

/* Services  */
app.service('commonService', ['$http', '$q', function ($http, $q) {
    this.getMatchCount = function (deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GetDeviceTurnCount", "TokenInfo": tokenInfo, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.doRegistration = function (userName, password, mobileDeviceId, firebaseId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "SubmitUser", "TokenInfo": tokenInfo, "UserDetail": { "UserName": userName, "Password": password, "MobileDeviceId": mobileDeviceId, "FirebaseId": firebaseId } } };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {

		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.doCheckDeviceIdValid = function (mobileDeviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "CheckDeviceId", "TokenInfo": tokenInfo, "UserDetail": { "MobileDeviceId": mobileDeviceId } } };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.doLogin = function (userName, password, mobileDeviceId, firebaseId, isMobileDeviceIdCheck) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "LoginUser", "AppVersion": curAppVersion, "TokenInfo": tokenInfo, "IsValid": false, "UserDetail": { "UserName": userName, "Password": password, "MobileDeviceId": mobileDeviceId, "FirebaseId": firebaseId, "IsMobileDeviceIdCheck": isMobileDeviceIdCheck } } };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getPlayerList = function (deviceId, searchName) {
        //alert(searchName); //, "Message": searchName
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GetPlayerList", "TokenInfo": tokenInfo, "DeviceId": deviceId, "Message": searchName } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getUsersForMatchRequest = function (deviceId) {
        //alert(searchName); //, "Message": searchName
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GetUsersForMatchRequest", "TokenInfo": tokenInfo, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

            .success(function (data) {
                var response = data;
                if (serviceUrl.indexOf(localRef) < 0) {
                    response = data.MakeRequestResult;
                }

                defer.resolve(response);
            })

            .error(function (resp, status, header) {
                defer.resolve(null);
            });

        return defer.promise;
    }

    this.sendGameRequest = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "SendMatchRequest", "TokenInfo": tokenInfo, "BoardDetail": {
                    "WhiteId": requestInfo.WhiteId, "BlackId": requestInfo.BlackId,
                    "RequestedBy": requestInfo.RequestedBy, "MoveDetail": requestInfo.MoveDetail, "Result": requestInfo.Result,
                    "ResultDesc": requestInfo.ResultDesc, "DaysPerMove": requestInfo.DaysPerMove, "HoursPerMove": requestInfo.HoursPerMove,
                    "MinutesPerMove": requestInfo.MinutesPerMove
                }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getMyGameList = function (deviceId, gameOption, gameFilterOption) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GetMyGameList", "TokenInfo": tokenInfo, "DeviceId": deviceId, "GameOption": gameOption, "GameFilter": { "MatchFilter": gameFilterOption } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getBoardDetail = function (boardId, deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GetBoardDetail", "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.submitBoardDetail = function (moveDetail) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "SaveMoveDetail", "TokenInfo": tokenInfo, "BoardDetail": moveDetail } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.approveOrRejectGameRequest = function (exeMode, boardId, deviceId, isApproved) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": exeMode, "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId, "IsValid": isApproved } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getPlayerStatistics = function (deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "PlayerStatistics", "TokenInfo": tokenInfo, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.claimWinExecute = function (boardId, deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "ClaimWinOnBoard", "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.resignMatchExecute = function (boardId, deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "ResignMatch", "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.drawMatchExecute = function (boardId, deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "DrawMatch", "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.approveRejectDrawRequest = function (boardId, deviceId, isApproved) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "ARDrawRequest", "TokenInfo": tokenInfo, "BoardId": boardId, "DeviceId": deviceId, "IsValid": isApproved } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getPlayerNofitication = function (deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "GN", "TokenInfo": tokenInfo, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getTournamentList = function (deviceId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "TL", "TokenInfo": tokenInfo, "DeviceId": deviceId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getTournamentDetail = function (deviceId, tournamentId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "TD", "TokenInfo": tokenInfo, "DeviceId": deviceId, "TournamentId": tournamentId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.manageTournamentDetail = function (deviceId, tournamentId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "MTD", "TokenInfo": tokenInfo, "DeviceId": deviceId, "TournamentId": tournamentId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.joinTournament = function (deviceId, tournamentId) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "JT", "TokenInfo": tokenInfo, "DeviceId": deviceId, "TournamentId": tournamentId } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.approveOrRejectTournament = function (deviceId, playerId, tournamentId, status) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "APPREJTOUR", "TokenInfo": tokenInfo, "DeviceId": deviceId, "TournamentId": tournamentId, "UserDetail": { "UserId": playerId, "IsActive": status } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.createFixtureForTournament = function (requestInfo) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "CF", "TokenInfo": tokenInfo, "BoardCreationDetail": { "WhiteId": requestInfo.WhiteId, "BlackId": requestInfo.BlackId, "TournamentId": requestInfo.TournamentId, "DeviceId": requestInfo.CreatedBy, "Round": requestInfo.Round, "MobileDeviceId": requestInfo.MobileDeviceId, "Comment": requestInfo.Comment } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getFixtureList = function (requestInfo) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "FIXTURELIST", "TokenInfo": tokenInfo, "FixtureModuleRequest": { "TournamentId": requestInfo.TournamentId, "DeviceId": requestInfo.DeviceId, "MobileDeviceId": requestInfo.MobileDeviceId, "Round": requestInfo.Round, "Result": requestInfo.Result } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.createBoardForFixture = function (fixtureDetail) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "CBF", "TokenInfo": tokenInfo, "FixtureDetail": fixtureDetail } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.changeTournamentStatus = function (requestInfo) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "CHGTOURSTATUS", "TokenInfo": tokenInfo, "FixtureModuleRequest": { "TournamentId": requestInfo.TournamentId, "DeviceId": requestInfo.DeviceId, "MobileDeviceId": requestInfo.MobileDeviceId, "TournamentStatusId": requestInfo.StatusId } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.updateTournamentDetail = function (requestInfo) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "UTD", "TokenInfo": tokenInfo, "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId }, "TournamentDetail": { "TournamentId": requestInfo.TournamentId, "DaysPerMove": requestInfo.DaysPerMove, "HoursPerMove": requestInfo.HoursPerMove, "MinutesPerMove": requestInfo.MinutesPerMove } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.generateAutoFixture = function (requestInfo) {
        var defer = $q.defer();

        var myObj = { "requestModule": { "ExeMode": "AUTOFIXTURE", "TokenInfo": tokenInfo, "FixtureModuleRequest": { "TournamentId": requestInfo.TournamentId, "DeviceId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId, "Round": requestInfo.Round } } };
        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.sendMessage = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "MSG", "TokenInfo": tokenInfo,
                "ChatDetail": { "LocalChatMessageId": requestInfo.LocalChatMessageId, "Message": requestInfo.Message, "BoardId": requestInfo.BoardId, "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getMessage = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "GETMSG", "TokenInfo": tokenInfo,
                "ChatDetail": { "BoardId": requestInfo.BoardId, "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.syncMessage = function (requestInfo, messageList) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "SYNCMSG", "TokenInfo": tokenInfo,
                "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId },
                "ChatMessageDetailList": messageList
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getNextConfirmationDetail = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "GCD", "TokenInfo": tokenInfo,
                "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId },
                "ContinueDetail": { "NextCode": requestInfo.NextCode }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.confirmAndGoNext = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "CGN", "TokenInfo": tokenInfo,
                "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId },
                "ContinueDetail": { "NextCode": requestInfo.NextCode }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getCommentType = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "CMTTYPE", "TokenInfo": tokenInfo,
                "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.submitUserComment = function (requestInfo) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "NEWCMT", "TokenInfo": tokenInfo,
                "UserDetail": { "UserId": requestInfo.UserId, "MobileDeviceId": requestInfo.MobileDeviceId },
                "UserCommentDetail": { "CommentTypeId": requestInfo.CommentTypeId, "Subject": requestInfo.Subject, "Description": requestInfo.Description, "SenderId": requestInfo.UserId }
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }

    this.getCMSDetail = function (title) {
        var defer = $q.defer();

        var myObj = {
            "requestModule": {
                "ExeMode": "CMS", "TokenInfo": tokenInfo,
                "Message": title
            }
        };

        if (serviceUrl.indexOf(localRef) >= 0) {
            myObj = myObj.requestModule;
        }

        var jsondata = JSON.stringify(myObj);

        $http.post(serviceUrl, jsondata, {
            transformRequest: angular.identity,
            headers: { 'Content-Type': 'application/json;charset=utf-8' }
        })

		.success(function (data) {
		    var response = data;
		    if (serviceUrl.indexOf(localRef) < 0) {
		        response = data.MakeRequestResult;
		    }

		    defer.resolve(response);
		})

		.error(function (resp, status, header) {
		    defer.resolve(null);
		});

        return defer.promise;
    }
}]);

app.service('UIService', ['$rootScope', '$http', '$q', '$filter', function ($rootScope, $http, $q, $filter) {

    this.showLoader = function (targetElement) {
        angular.element(targetElement).find('.loader').show();
    };

    this.hideLoader = function (targetElement) {
        angular.element(targetElement).find('.loader').hide();
    };
}])